(function() {
	tinymce.create('tinymce.plugins.PhotoshowPlugin', {
		 // @param {tinymce.Editor} ed Editor instance that the plugin is initialized in.
		 // @param {string} url Absolute URL to where the plugin is located.
		init : function(ed, url) {
			// Register commands
			ed.addCommand('mcePhotoshow', function() {
				if(ed.dom.getAttrib(ed.selection.getNode(), "class").indexOf("mceItem")!=-1) {return}
				ed.windowManager.open({
					file : url + '/photoshow.php',
					width : 500 + parseInt(ed.getLang('photoshow.delta_width', 0)),
					height : 460+ parseInt(ed.getLang('photoshow.delta_height', 0)),
					inline : 1
				}, {
					plugin_url : url
				});
			});
						// Register example button
			ed.addButton('photoshow', {
				title : 'Photoshow',
				cmd : 'mcePhotoshow',
				image : url + '/img/photoshow.gif'
			});
			// Add a node change handler, selects the button in the UI when a image is selected
			ed.onNodeChange.add(function(ed, cm, n) {
			  var node=n;
				if (node.nodeName=='TD' && node.parentNode.nodeName == 'TR' && node.parentNode.parentNode.nodeName == 'TBODY' && node.parentNode.parentNode.parentNode.nodeName == 'TABLE') {
      		node=node.parentNode.parentNode.parentNode;
				}
				if ((node.nodeName == 'TABLE') && (ed.dom.getAttrib(node,'photoshow'))) {
					cm.setActive('photoshow', true);
					cm.setActive('table', false);
				} else cm.setActive('photoshow', false);
			});
		},
		getInfo : function() {
			return {
				longname : 'PhotoShow',
				author : 'Jean-Paul GIAUSSERAND',
				authorurl : 'http://www.giausserand.fr/index.php?perma=ziteplus',
				infourl : 'http://www.giausserand.fr/index.php?perma=ziteplus',
				version : tinymce.majorVersion + "." + tinymce.minorVersion
			};
		}
	});
	// Register plugin
	tinymce.PluginManager.add('photoshow', tinymce.plugins.PhotoshowPlugin);
})(tinymce);

