<?php
require_once('../../../zplus/ziteplus.php');
//
require_once('config_tinybrowser.php');
// Set language
if(isset($tinybrowser['language']) && file_exists('langs/'.$tinybrowser['language'].'.php')){
	require_once('langs/'.$tinybrowser['language'].'.php'); 
}else{
	require_once('langs/en.php'); // Falls back to English
}
require_once('fns_tinybrowser.php');

// Check session, if it exists
if(session_id() != '')
	{
	if(!isset($_SESSION[$tinybrowser['sessioncheck']]))
		{
		echo TB_DENIED;
		exit;
		}
	}
// Assign file operation variables
$validtypes = array('image','media'/*,'file'*/);
$typenow = ((isset($_GET['type']) && in_array($_GET['type'],$validtypes)) ? $_GET['type'] : 'image');
$zptypenow=$typenow=='media'?'film':'img';
$foldernow = str_replace(array('../','..\\','./','.\\'),'',($tinybrowser['allowfolders'] && isset($_REQUEST['folder']) ? urldecode($_REQUEST['folder']) : ''));

// Assign browsing options
$sortbynow = (isset($_REQUEST['sortby']) ? $_REQUEST['sortby'] : $tinybrowser['order']['by']);
$sorttypenow = (isset($_REQUEST['sorttype']) ? $_REQUEST['sorttype'] : $tinybrowser['order']['type']);
$sorttypeflip = ($sorttypenow == 'asc' ? 'desc' : 'asc');  
$viewtypenow = (isset($_REQUEST['viewtype']) ? $_REQUEST['viewtype'] : $tinybrowser['view']['image']);
$showpagenow = (isset($_REQUEST['showpage']) ? $_REQUEST['showpage'] : 1);

// Assign url pass variables
$passfolder = '&folder='.urlencode($foldernow);
$passviewtype = '&viewtype='.$viewtypenow;
$passsortby = '&sortby='.$sortbynow.'&sorttype='.$sorttypenow;

// Assign view, thumbnail and link paths
$browsepath = $tinybrowser['path'][$typenow].$foldernow;
$linkpath = $tinybrowser['link'][$typenow].$foldernow;
$thumbpath = $tinybrowser[$tinybrowser['thumbsrc']][$typenow].$foldernow;

// Assign sort parameters for column header links
$sortbyget = array();
$sortbyget['name'] = '&viewtype='.$viewtypenow.'&sortby=name';
$sortbyget['size'] = '&viewtype='.$viewtypenow.'&sortby=size'; 
$sortbyget['type'] = '&viewtype='.$viewtypenow.'&sortby=type'; 
$sortbyget['modified'] = '&viewtype='.$viewtypenow.'&sortby=modified';
$sortbyget['dimensions'] = '&viewtype='.$viewtypenow.'&sortby=dimensions'; 
$sortbyget[$sortbynow] .= '&sorttype='.$sorttypeflip;
// Assign css style for current sort type column
$thclass = array();
$thclass['name'] = '';
$thclass['size'] = ''; 
$thclass['type'] = ''; 
$thclass['modified'] = '';
$thclass['dimensions'] = ''; 
$thclass[$sortbynow] = ' class="'.$sorttypenow.'"';

// Initalise alert array
$notify = array(
	'type' => array(),
	'message' => array()
);
$newthumbqty = 0;

// read folder contents if folder exists
//session_start();  // Pour rcuprer la variable $_SESSION
$basesite = substr($_SERVER['SCRIPT_FILENAME'],0,stripos($_SERVER['SCRIPT_FILENAME'],'tinymce')); // voir si script_filename existe sur tous les serveurs
$tinybrowser['docroot']=$basesite;
$browsepath ='zdata/zdocs/';
$thumbpath = 'thumb.php/';
$linkpath = 'view.php/';
$zp=new zpbase($basesite);
require_once($basesite.'zplus/module/selectdoc.php');
$selectdoc=Tmodule::create_module('selectdoc');
$filterdoc=isset($_SESSION['doc_filter'])?$_SESSION['doc_filter']:$selectdoc->getOption('docfilter');
$filterval=isset($_SESSION['doc_filterval'])?$_SESSION['doc_filterval']:null;
if (isset($_POST['search'])) {
	  $filterdoc=(int)$_POST['filterdoc'];
	  $filterval=$_POST['filterval'];
	  $_SESSION['doc_filter']=$filterdoc;
	  $_SESSION['doc_filterval']=$filterval;
}
// Assign Permissions for Upload, Edit, Delete & Folders
$tinybrowser['allowupload']=false;//provisoire:va tre utilis pour ajout de documents images par lots
$tinybrowser['allowedit']=false;//provisoire
$tinybrowser['allowdelete']=false;//provisoire
$tinybrowser['allowfolders']=false;//provisoire:va tre utilis avec les rubriques
define(TB_FILENAME,'Lien');
require_once($basesite.'zplus/tdocsadmin.php');
$docs = new Tdocsadmin($basesite.'zdata/docs.dta');
$docs->setfilter($filterdoc,$filterval);
if ($sortbynow=='name'){
	$docs->sort(cDocDesc,$sorttypeflip=='desc');
}elseif ($sortbynow=='type'){
	$docs->sort(cDocExt,$sorttypeflip=='desc');
}elseif ($sortbynow=='modified'){
	$docs->sort(cDocDate,$sorttypeflip=='desc');
}
	// lire les documents et remplir le tableau $file (hritage tinybrowser de base)
$file = array();
foreach ($docs as $ident => $doc) {
	$filename = $doc[cDocFilename];
		// filter directories and prohibited file types
	if ($docs->isDocAuth($ident)&&($docs->getvalues($ident,cDocType)==$zptypenow)) {//Prendre les documents permis de type image
		// assign file details to array
		$file['ident'][] = $ident;
		$file['name'][] = $ident;
		$file['sortname'][] = strtolower($doc[cDocDesc]);;
		$file['modified'][] = $doc[cDocDate];//filemtime($tinybrowser['docroot'].$browsepath.$filename);
		$file['size'][] = filesize($tinybrowser['docroot'].$browsepath.$filename);
			// image specific info or general
		if($typenow=='image' && $imginfo = getimagesize($tinybrowser['docroot'].$browsepath.$filename))	{
			$file['width'][] = $imginfo[0];
			$file['height'][] = $imginfo[1];
			$file['dimensions'][] = $imginfo[0] + $imginfo[1];
			$file['type'][] = $imginfo['mime']; // prendre valeur ziteplus
		  if ($docs->makethumb($ident)) $newthumbqty++; // Crer la vignette si elle n'existe pas
		}	else {
			$file['width'][] = 'N/A';
			$file['height'][] = 'N/A';
			$file['dimensions'][] = 'N/A';
			$file['type'][] = returnMIMEType($filename);
		}
	}
 }

// Assign directory structure to array
$browsedirs=array();
//dirtree($browsedirs,$tinybrowser['filetype'][$typenow],$tinybrowser['docroot'],$tinybrowser['path'][$typenow]); //????????????????????????????????????
	
// generate alert if new thumbnails created
if($newthumbqty>0)
   {
	$notify['type'][]='info';
	$notify['message'][]=sprintf(TB_MSGNEWTHUMBS, $newthumbqty);
	}
	

// determine sort order
$sortorder = ($sorttypenow == 'asc' ? SORT_ASC : SORT_DESC);
$num_of_files = (isset($file['name']) ? count($file['name']) : 0);

if($num_of_files>0)	{
	if ($sortbynow!='name' && $sortbynow!='type' && $sortbynow!='modified'){// si pas dj tri dans documents
		sortfileorder($sortbynow,$sortorder,$file);		// sort files by selected order
	}
}

// determine pagination
if($tinybrowser['pagination']>0)	{
	$showpage_start = (isset($_REQUEST['showpage']) ? ($_REQUEST['showpage']*$tinybrowser['pagination'])-$tinybrowser['pagination'] : 0);
	$showpage_end = $showpage_start+$tinybrowser['pagination'];
	if($showpage_start>$num_of_files) $showpage_start = 0;
	if($showpage_end>$num_of_files) $showpage_end = $num_of_files;
}else	{
	$showpage_start = 0;
	$showpage_end = $num_of_files;
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
<head>
<title>TinyBrowser :: <?php echo TB_BROWSE; ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta http-equiv="Pragma" content="no-cache" />
<script language="javascript" type="text/javascript">
	function myclick(id) {
		obj=document.getElementById("showpage");
		obj.value=id;
		document.forms['browse'].submit();
	}

</script>
<?php
if($tinybrowser['integration']=='tinymce')
	{
	?><script language="javascript" type="text/javascript" src="../../tiny_mce_popup.js"></script>
	<link rel="stylesheet" type="text/css" media="all" href="<?php echo $tinybrowser['tinymcecss']; ?>" /><?php
	}
else
	{
	?><link rel="stylesheet" type="text/css" media="all" href="css/stylefull_tinybrowser.css" /><?php 
	}
?>
<link rel="stylesheet" type="text/css" media="all" href="css/style_tinybrowser.css.php" />
<script language="javascript" type="text/javascript" src="js/tinybrowser.js.php"></script>
</head>
<body>
<?php
if(count($notify['type'])>0) alert($notify);
form_open('foldertab',false,'tinybrowser.php','?type='.$typenow.$passviewtype.$passsortby);
?>
<div class="tabs">
<ul>
<li id="browse_tab" class="current"><span><a href="tinybrowser.php?type=<?php echo $typenow.$passfolder; ?>"><?php echo TB_BROWSE; ?></a></span></li><?php
if($tinybrowser['allowupload']) 
	{
	?><li id="upload_tab"><span><a href="upload.php?type=<?php echo $typenow.$passfolder; ?>"><?php echo TB_UPLOAD; ?></a></span></li><?php
	}
if($tinybrowser['allowedit'] || $tinybrowser['allowdelete'])
	{
	?><li id="edit_tab"><span><a href="edit.php?type=<?php echo $typenow.$passfolder; ?>"><?php echo TB_EDIT; ?></a></span></li><?php
	}
if($tinybrowser['allowfolders'])
	{
	?><li id="folders_tab"><span><a href="folders.php?type=<?php echo $typenow.$passfolder; ?>"><?php echo TB_FOLDERS; ?></a></span></li><?php
	}
// Display folder select, if multiple exist
if(count($browsedirs)>1)
	{
	?><li id="folder_tab" class="right"><span><?php
	form_select($browsedirs,'folder',TB_FOLDERCURR,urlencode($foldernow),true);
	?></span></li><?php
	}
//echo $zp->ipath;
//echo 	dirname($_SERVER['SCRIPT_FILENAME']);
$base = $_SESSION['url_rewritebase'].$zp->config['files_index'].'?z=';
//echo '<div style="text-align:right"><a href="'.$base.'selectdoc|new"  target="_blank"><img src="'.$_SESSION['url_rewritebase'].'/deco/a.png" /> '.$selectdoc->get_Message('btnadd').'</a> <a href="'.$base.'selectdoc|news"  target="_blank"><img src="../../../deco/a.png" /> '.$selectdoc->get_Message('btnadds').'</a></div>';
?>
</ul>
</div>
</form>
<div class="panel_wrapper">
<div id="general_panel" class="panel currentmod">
<fieldset>
<legend><?php echo TB_BROWSEFILES; ?></legend>
<?php
form_open('browse','custom','tinybrowser.php','?type='.$typenow.$passfolder);
//
// Show page select if pagination is set
if($tinybrowser['pagination']>0){
	$pagelimit = ceil($num_of_files/$tinybrowser['pagination'])+1;
	$page = array();
	for($i=1;$i<$pagelimit;$i++){
		$page[] = array($i,TB_PAGE.' '.$i);
	}
}
echo '<div style="text-align:left">Allez a la page: ';
for($i=1;$i<$pagelimit;$i++){
	echo '<img src="'.$_SESSION['url_rewritebase'].'deco/pge'.($i==$showpagenow?'1':'0').'.png" onclick="myclick('.$i.')";/> ';
}
echo '</div>';

?>
<div class="pushleft">
<?php

// Offer view type if file type is image
if($typenow=='image')
	{
	$select = array(
		array('thumb',TB_THUMBS),
		array('detail',TB_DETAILS)
	);
	form_select($select,'viewtype',TB_VIEW,$viewtypenow,true);
	}
// Show page select if pagination is set
if($tinybrowser['pagination']>0)
	if($i>2) form_select($page,'showpage',TB_SHOW,$showpagenow,true);
?></div><div class="pushright"><?php

form_hidden_input('sortby',$sortbynow);
form_hidden_input('sorttype',$sorttypenow);

echo $selectdoc->get_message('filter').' <select name="filterdoc">';
$list=explode(':','1:2:3:4:7:8');
foreach ($list as $k1 => $v1)
	echo '<option value="'.$v1.'"'.($v1==$filterdoc?' selected ':'').'>'.utf8_encode($selectdoc->get_message('docfilter_'.$v1)).'</option>';
echo '</select>';
form_text_input('filterval',false,$filterval,25,50);
form_submit_button('search',$selectdoc->get_message('filter'),'');
?></div>
<?php


// if image show dimensions header
if($typenow=='image')
	{
	$imagehead = '<th><a href="?type='.$typenow.$passfolder.$sortbyget['dimensions'].'"'.$thclass['dimensions'].'>'.TB_DIMENSIONS.'</a></th>';
	}
else $imagehead = '';

echo '<div class="tabularwrapper"><table class="browse">'
		.'<tr><th><a href="?type='.$typenow.$passfolder.$sortbyget['name'].'"'.$thclass['name'].'>'.$selectdoc->get_message('docdesc').'</a></th>'
		.'<th><a href="?type='.$typenow.$passfolder.$sortbyget['size'].'"'.$thclass['size'].'>'.TB_SIZE.'</a></th>'
		.$imagehead
		.'<th><a href="?type='.$typenow.$passfolder.$sortbyget['type'].'"'.$thclass['type'].'>'.TB_TYPE.'</th>'
		.'<th><a href="?type='.$typenow.$passfolder.$sortbyget['modified'].'"'.$thclass['modified'].'>'.TB_DATE.'</th></tr>';

// show image thumbnails, unless detail view is selected
if($typenow=='image' && $viewtypenow != 'detail')	{
	echo '</table></div>';
	for($i=$showpage_start;$i<$showpage_end;$i++)	{
		echo '<div class="img-browser"><a href="#" onclick="selectURL(\''.$linkpath.$file['ident'][$i].'\',\''.$docs->getvalues($file['ident'][$i],cDocDesc).'\');" title="'.TB_FILENAME.': '.$file['ident'][$i]
				.'&#13;&#10;'.TB_DIMENSIONS.': '.$file['width'][$i].' x '.$file['height'][$i]
				.'&#13;&#10;'.TB_DATE.': '.$file['modified'][$i]//.date($tinybrowser['dateformat'],$file['modified'][$i])
				.'&#13;&#10;'.TB_TYPE.': '.$file['type'][$i]
				.'&#13;&#10;'.TB_SIZE.': '.bytestostring($file['size'][$i],1)
				.'"><img src="'.$_SESSION['url_rewritebase'].$thumbpath.$file['ident'][$i] 
				.'"  /><div class="filename">'.$docs->getValues($file['ident'][$i],cDocDesc).'</div></a></div>';
	}
} else {
	for($i=$showpage_start;$i<$showpage_end;$i++)	{
		$alt = (IsOdd($i) ? 'r1' : 'r0');
		echo '<tr class="'.$alt.'">';
		if($typenow=='image') echo '<td><a class="imghover" href="#" onclick="selectURL(\''.$linkpath.$file['ident'][$i].'\',\''.$docs->getvalues($file['ident'][$i],cDocDesc).'\');" title="'.$file['ident'][$i].'"><img src="'.$_SESSION['url_rewritebase'].$thumbpath.$file['ident'][$i].'" alt="" />'.truncate_text($docs->getvalues($file['ident'][$i],cDocDesc),30).'</a></td>';
		else echo '<td><a href="#" onclick="selectURL(\''.$linkpath.$file['ident'][$i].'\',\''.$docs->getvalues($file['ident'][$i],cDocDesc).'\');" title="'.$file['ident'][$i].'">'.truncate_text($file['ident'][$i],30).'</a></td>';
		echo '<td>'.bytestostring($file['size'][$i],1).'</td>';
		if($typenow=='image') echo '<td>'.$file['width'][$i].' x '.$file['height'][$i].'</td>';	
		echo '<td>'.$file['type'][$i].'</td>'
			.'<td>'.$file['modified'][$i].'</td></tr>'."\n";//date($tinybrowser['dateformat'],$file['modified'][$i]).'</td></tr>'."\n";
	}
	echo '<tr><td colspan="5"><br /><br/<br/></td></tr></table></div>';
}

?>
</fieldset></div></div>
<form name="passform"><input name = "fileurl" type="hidden" value= "" /></form>
</body>
</html>
