<?php
/*
module:	Gestion des documents - V1.8
Copyright Jean-Paul GIAUSSERAND 2009-2012
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.8: Correction mineure - gestion caractres spciaux
	v1.7: Optimisation vitesse traitement des documents
	v1.6: Correction gestion caractres accentus
	v1.5: Ajout gestion des rubriques
	v1.5: Passage en code objet
	v1.4: Ajout gestion des vignettes
	v1.3: Ajout du tri des documents
	v1.2: Affichage du nombre de document
	v1.1: Ajout de la scurit
	v1.0: cration du module
*/
class Tselectdoc extends Tmodule {
	protected function loadfile($src, $path, &$name, &$filename, &$ext, $ancfilename) {
		$cms=self::$cms;
  	$handle = $_FILES[$src];
		if (!empty($handle) && ($handle['error']==0)) {
		  $filename = strtolower(stripslashes($handle['name']));
		  if (($filename!=$ancfilename)&& file_exists($path.$filename)) {
		  	return self::$cms->msgShow($this->get_message('errdupfilename'),false);
			} else {
				$prov01 = pathinfo($filename);
				$ext = strtolower($prov01['extension']);
				$name = basename($filename,'.'.$ext); // enlever l'extension
				$temp_file = $handle['tmp_name'];
				if ($handle['size']>$cms->get_data('upload_maxweight')) {
					return self::$cms->msgShow($this->get_message('errtoobig2'),false);
				} elseif (in_array($ext, explode(',', $cms->get_data('upload_types')))) {
				  if ($ancfilename && ($filename<>$ancfilename)) @unlink($path.$ancfilename);
					return @move_uploaded_file($temp_file, $path.$filename);
	    	} else return $cms->msgShow($this->get_message('errbadtype'),false);
	    }
    } else {
				switch ($handle['error']){
					case 1: // UPLOAD_ERR_INI_SIZE
          	$cms->msgShow($this->get_message('errtoobig1'),false);
						break;
					case 2: // UPLOAD_ERR_FORM_SIZE
    				$cms->msgShow($this->get_message('errtoobig2'),false);
						break;
					case 3: // UPLOAD_ERR_PARTIAL
          	$cms->msgShow($this->get_message('errpartial'),false);
						break;
					case 4: // UPLOAD_ERR_NO_FILE
            $cms->msgShow($this->get_message('errnullsize'),false);
						break;
					default:
					  $cms->msgShow('done_failed: '.$handle['error'],false);
        }
        return false;
		 }
	}//end-loadfile
		// si plusieurs fichier
	protected function setfiles($files, $path, &$zdocs,&$err, &$good, &$groupR,&$groupW,&$rub ) {
		$cms=self::$cms;
		$err=array();// les fichiers en erreurs avec les messages associs
		$good=array();//Les fichiers uploads sur le serveurs dans le bon rpertoire
		if (!empty($files)) {
	  	foreach($files as $ident) {// Pour chaque fichier tlcharg
	  	  $ident = str_ireplace(array('/','\\','*','@'),array('','','',''),stripslashes($ident));
  		  $msg=$ident.' : ';
//	  	  print_r($ident.'<br/>');
				$filename=strtolower($ident); // Nom du fichier disque
				$temp_file = $cms->cpath.'/ztemp/files/'.session_id().'/'.$ident;
				$prov01 = pathinfo($filename);
				$ext = strtolower($prov01['extension']);
   	  	$dest=$path.$filename;
				if (filesize($temp_file)>$cms->get_data('upload_maxweight')) {
					$err[]=$msg.$this->get_message('errtoobig2');
				} elseif (!in_array($ext, explode(',', $cms->get_data('upload_types')))) {
					$err[]=$msg.$this->get_message('errbadtype');
	    	} elseif (file_exists($dest)&&($zdocs->getValues($ident,cDocFilename)!=$filename)) {
   	  	  $err[]=$msg.$this->get_message('errdupfilename');
				} elseif (file_exists($dest)&&!$zdocs->isDocAuth($ident)) {
					$err[]=$msg.$this->get_message('errnoright');
			  } else {
					if (file_exists($dest)) @unlink($path.$ancfilename);
					@rename($temp_file,$dest);
//					$auth = $_SESSION['zite_user'];
					$ext=$desc=$auth=$type=$docdate='';
					$zdocs->verifdoc($filename,$ident,$ext,$rub,$desc,$auth,$groupW,$groupR,$type,$docdate);
					$zdocs->updateDoc($ident,$filename,$ext,$rub,$desc,$auth,$groupW,$groupR,$type,$docdate);
					$good[$ident]=$filename;
	    	  if (file_exists($temp_file)) @unlink($temp_file);
				}
			}
	  } else $err[]=$this->get_message('errnofile');
		return empty($err);
	}//end-loadfiles
//
	function dojob($opt="") {
//		parent::dojob();
		// Propre  ce module: il faut un utilisateur sign
		if (empty($_SESSION['zite_user']))
			return self::$cms->get_message('not_allowed');
		require_once self::$cms->zpath.'/tdocsadmin.php';
		//	Tdocsadmin::set_cms($zite);
		require_once(self::$cms->zpath.'/outils.php');
		//
		if (isset(self::$cms->args[1])&& (self::$cms->args[1]=='go')&&($_SESSION['zite_admin']==2)) {//pour test  finir:  relancer si temps trop important
  	  @set_time_limit(0);
			$zdocs = new Tdocsadmin(self::$cms->cpath.'/docs.dta');
			$zdocs->makethumbs();
			unset($zdocs);
			return self::$cms->msgShow('done_ok');
			exit;
		}
	$zdocs = new Tdocsadmin(self::$cms->cpath.'/docs.dta');	$zdocsR = new Tdocs('');
	$out='';
		  // dfinir la fonction javascript qui remplit automatiquement doctitle si vide
	self::$cms->content['js'].='
   <script language="Javascript" type="text/javascript">
			 function auto_doctitle(form) {
					if (form.ident.value.length==0){document.getElementById("ident").value=document.getElementById("file").value.replace(/.*[\/\\\]/ , "" )};
					if (form.desc.value.length==0){document.getElementById("desc").value=document.getElementById("file").value.replace(/.*[\/\\\]/ , "" ).replace(/\.[a-zA-z_0-9]*$/ , "" );}
					document.getElementById("filename").value=document.getElementById("file").value.replace(/.*[\/\\\]/ , "" );
					document.getElementById("ext").value=document.getElementById("file").value.replace(/^.*\./, "" );
					switch(document.getElementById("ext").value){ case "jpg": case "gif": case "png": case"jpe": case "jpeg": document.getElementById("type").value="img"; break; case "pdf": document.getElementById("type").value="pdf"; break; default:document.getElementById("type").value="";};}
					</script>';
	$out2= ($this->isConfig($this->modulename)?'<a href="'.self::$cms->base.'selectmodule|config|'.$this->ident.'" title="configurer le module"><img src="deco/config.png"/></a>':'');
	$out .= '<form name="formdocs" method="post" action="'.self::$cms->base.'selectdoc" enctype="multipart/form-data"><table class="ztable">';
	$out .= '<tr><td colspan="2" style="text-align:center"><img src="deco/docs.png" style="float:left" /><span style="float:right">'.$out2.'</span><h2>'.$this->get_message('title').'</h2><td></tr>';
	if (isset(self::$cms->args[2])) {
		$ident = self::$cms->args[2];
	  $filename = $zdocsR->getvalues($ident,cDocFilename);
	  $desc = $zdocsR->getvalues($ident,cDocDesc);
	  $rub = (array)$zdocsR->getvalues($ident,cDocRub);
	  $auth = $zdocsR->getvalues($ident,cDocAuth);
		$type = $zdocsR->getvalues($ident,cDocType);
		$ext = $zdocsR->getvalues($ident,cDocExt);
		$groupW = (array)$zdocsR->getvalues($ident,cDocWrite);
		$groupR = (array)$zdocsR->getvalues($ident,cDocRead);
		$docdate = $zdocsR->getvalues($ident,cDocDate);
	} else {
		$ident = isset($_POST['ident'])?$_POST['ident']:'';
		$file = isset($_POST['file'])?(array)$_POST['file']:array();
	  $filename = isset($_POST['filename'])?$_POST['filename']:''; // vide si cration
	  $type = isset($_POST['type'])?$_POST['type']:''; // vide si cration
	  $ext = isset($_POST['ext'])?$_POST['ext']:''; // vide si cration
		$desc = isset($_POST['desc'])?$_POST['desc']:'';
		$rub = isset($_POST['rub'])?(array)$_POST['rub']:array();
		$auth = $_SESSION['zite_user'];
		$groupW = isset($_POST['groupW'])?(array)$_POST['groupW']:array();
		$groupR = isset($_POST['groupR'])?(array)$_POST['groupR']:array();
		$docdate = isset($_POST['date'])?$_POST['date']:date("d/m/Y");
	}
 	$tridoc=isset($_SESSION['doc_sort'])?$_SESSION['doc_sort']:$this->getOption('docsort');
 	$updown=isset($_SESSION['doc_asc'])?$_SESSION['doc_asc']:$this->getOption('updown');
 	$filterdoc=isset($_SESSION['doc_filter'])?$_SESSION['doc_filter']:$this->getOption('docfilter');
	$filterval=isset($_SESSION['doc_filterval'])?$_SESSION['doc_filterval']:null;
	$err ='';
	if ($err) {//pas en service pour l'instant
		$out.= $err;
		self::$cms->args[1]=substr($_POST['save'],0,strlen($_POST['save'])-1);
	} elseif (isset($_POST['tridoc'])||isset($_POST['updown'])||!empty($_POST['trijs'])) {//Changement critres de tri
	  if ($_POST['trijs']&&($tridoc==$_POST['tri']))
	    $_POST['updown']=true;
	  $tridoc = (int)$_POST['tri'];
		$_SESSION['doc_sort']=$tridoc;
	  if (isset($_POST['updown'])){
			$updown = (bool)$_POST['asc'];
			$updown = !$updown;
			$_SESSION['doc_asc']=$updown;
		}
//	} elseif (isset($_POST['docreadall'])) {
	} elseif (isset($_POST['filter'])) {
	  $filterdoc=(int)$_POST['filterdoc'];
	  $filterval=$_POST['filterval'];
	  $_SESSION['doc_filter']=$filterdoc;
	  $_SESSION['doc_filterval']=$filterval;
	} elseif (isset($_POST['delupload'])) {//Effacer les fichiers en attente de cration
		$dest = self::$cms->cpath.'/ztemp/files/'.session_id().'/';
		$files=array_diff(@scandir($dest),array('.','..'));$files= is_array($files)?$files:array();
	  foreach($files as $name)
			@unlink($dest.'/'.$name);
		self::$cms->args[1]='news';//Il faut rester en gestion multi-document
 	} elseif (isset($_POST['docreadall'])) {
	  $groupR = array();
		self::$cms->args[1]=substr($_POST['save'],0,strlen($_POST['save'])-1);
		self::$cms->args[2]=$filename;
	} elseif (isset($_POST['docwritegroup'])) {
	  $groupW = array_diff($_SESSION['zite_usergroup'],array('logon'));
		self::$cms->args[1]=substr($_POST['save'],0,strlen($_POST['save'])-1);
		self::$cms->args[2]=$filename;
	} elseif (isset($_POST['abort'])) {
	} else if (isset($_POST['save'])) {
		if ($_POST['save']=='modif1') {
			self::$cms->args[1] = 'modif';       // en cas d'erreur
			if ($zdocs->isDocAuthWrite($ident)) {
				if (empty($_FILES['file']['name'])||$this->loadfile('file',self::$cms->dpath.'/', $name,$filename,$ext,$zdocs->getvalues($ident,cDocFilename))) {
  				$auth = $_SESSION['zite_user'];
					$zdocs->verifdoc($filename,$ident,$ext,$rub,$desc,$auth,$groupW,$groupR,$type,$docdate);
						// ! il faut bien vrifier que l'on crase pas un fichier sur lequel on n'a pas les droits !!!
					$zdocs->updateDoc($ident, $filename,$ext,$rub,$desc,$auth,$groupW,$groupR,$type,$docdate);
					self::$cms->args[1]='';
					unset($name); unset($ext);
				}
			}
			if (self::$cms->args[1]=='modif') self::$cms->msgShow('done_failed');
		}	elseif ($_POST['save']=='new1') {
			self::$cms->args[1] = 'new';       // en cas d'erreur
			if (!$zdocs->isDoc($ident)) { //oups: le document existe dj
				if ($this->loadfile('file',self::$cms->dpath.'/', $name,$filename,$ext,'')) {
					$auth = $_SESSION['zite_user'];
					$zdocs->verifdoc($filename,$ident,$ext,$rub,$desc,$auth,$groupW,$groupR,$type,$docdate);
					$zdocs->updateDoc($ident , $filename,$ext,$rub,$desc,$auth,$groupW,$groupR,$type,$docdate);
					self::$cms->args[1]='';
					unset($name); unset($ext);
				}
			} else self::$cms->msgShow($this->get_message('errdocexist'),false);
			if (self::$cms->args[1]=='new') self::$cms->msgShow('done_failed');
		} elseif ($_POST['save']=='news1') {//091
			self::$cms->args[1] = 'news';       // en cas d'erreur
			$dest = self::$cms->cpath.'/ztemp/files/'.session_id().'/';
		  $files=array_diff(@scandir($dest),array('.','..'));$files= is_array($files)?$files:array();
			if ($this->setfiles($files,self::$cms->dpath.'/', $zdocs,$err,$good,$groupR,$groupW,$rub)) {
				self::$cms->args[1]='';
			} else {
			  foreach($err as $msg)
			  	self::$cms->msgShow($msg,false);
			}
			if (self::$cms->args[1]=='news') self::$cms->msgShow('done_failed');
		} elseif ($_POST['save']=='del1') {
				self::$cms->args[1] = 'del';
				$ident = $_POST['docname'];
				if ($zdocs->isDocAuthWrite($ident)) {
					unlink(self::$cms->dpath.'/'.$zdocs->getvalues($ident,cDocFilename));
					@unlink(self::$cms->dpath.'/thumbs/'.$zdocs->getvalues($ident,cDocFilename));
					$zdocs->removeDoc($ident);
					self::$cms->args[1]='';
				}
				if (self::$cms->args[1]!='') self::$cms->msgShow('done_failed');
		} elseif ($_POST['save']=='delall1') {
				self::$cms->args[1] = 'delall';
				self::$cms->args[1]=''; //                                  FINIR
				foreach ($_POST['docsident'] as $ident) {
					if ($zdocs->isDocAuthWrite($ident)) {
						unlink(self::$cms->dpath.'/'.$zdocs->getvalues($ident,cDocFilename));
						@unlink(self::$cms->dpath.'/thumbs/'.$zdocs->getvalues($ident,cDocFilename));
						$zdocs->removeDoc($ident);
					}
				}
				if (self::$cms->args[1]!='') self::$cms->msgShow('done_failed');
		} elseif ($_POST['save']=='setall1') {
				self::$cms->args[1] = 'setall';
				foreach ($_POST['docsident'] as $ident) {
					if ($zdocs->isDocAuthWrite($ident)) {
					  $doc=$zdocs[$ident];
						$doc[cDocRub]=isset($_POST['rub'])?$_POST['rub']:array();
					  $doc[cDocWrite]=isset($_POST['groupW'])?$_POST['groupW']:array();
					  $doc[cDocRead]=isset($_POST['groupR'])?$_POST['groupR']:array();
					  $zdocs[$ident]=$doc;
//					$zdocs->verifdoc($filename,$ident,$ext,$rub,$desc,$auth,$groupW,$groupR,$type,$docdate);
//					$zdocs->updateDoc($ident,$filename,$ext,$rub,$desc,$auth,$groupW,$groupR,$type,$docdate);
//					$good[$ident]=$filename;
//						unlink(self::$cms->dpath.'/'.$zdocs->getvalues($ident,cDocFilename));
//						@unlink(self::$cms->dpath.'/thumbs/'.$zdocs->getvalues($ident,cDocFilename));
//						$zdocs->removeDoc($ident);
					}
				}
				$zdocs->save();
				self::$cms->args[1]=''; //                                  FINIR
				if (self::$cms->args[1]!='') self::$cms->msgShow('done_failed');
		}
	}
	$extok='*.'.implode(';*.',explode(',',self::$cms->get_data('upload_types')));
	unset($zdocsR);	$zdocsR = new Tdocs('');

	$out .= '<tr><td align="left">'.$zdocsR->count().' Document(s) dont '.$zdocs->count().' modifiable(s)</td><td align="right"><a href="'.self::$cms->base.'selectdoc|new"><img src="deco/a.png" />'.$this->get_Message('btnadd').'</a> <a href="'.self::$cms->base.'selectdoc|news"><img src="deco/a.png" />'.$this->get_Message('btnadds').'</a></td></tr>';
	$out .= '</table><table class="ztable">';
	$show_listdoc = true;
	if (isset(self::$cms->args[1]))
		switch (self::$cms->args[1]) {
		  case 'news' :  // Ajouter un group de documents
				self::$cms->content['css'].='
				 <link href="js/uploadify/default.css" rel="stylesheet" type="text/css" />
				 <link href="js/uploadify/uploadify.css" rel="stylesheet" type="text/css" />';
				if (self::$cms->jquery_load==2) self::$cms->jquery_load=true;
				self::$cms->content['js'].='
				 <script type="text/javascript" src="js/uploadify/swfobject.js"></script>
				 <script type="text/javascript" src="js/uploadify/jquery.uploadify.v2.1.0.min.js"></script>
				 <script type="text/javascript">
				 $(document).ready(function() {
					$("#uploadify").uploadify({
						"uploader"      : "js/uploadify/uploadify.swf",
						"script"        : "js/uploadify/uploadify.php?id='.session_id().'",
						"checkScript"   : "js/uploadify/check.php?id='.session_id().'",
						"cancelImg"      : "js/uploadify/cancel.png",
						"folder"         : "aucun",
						"queueID"        : "fileQueue",
						"auto"           : false,
						"multi"         : true,
						"simUploadLimit" : 1,
						"fileDesc"	:	"'.$extok.'",
						"fileExt"	:	"'.$extok.'",
						"cancelImg"	:	"deco/e1.png",
						"sizeLimit"	:	"'.self::$cms->get_data('upload_maxweight').'",
						"buttonText"  : "'.$this->get_message('browse').'",
						"buttonImg" : "",
						"hideButton" : false,
						"onAllComplete": function(event,data) { document.location.href="'.self::$cms->base.'selectdoc|news";}
					});
				 });
				 </script>';
				$groupW = array_diff($_SESSION['zite_usergroup'],array('logon'));
				$groupR = array();
				$rub=array();
				$out.='<tr><td colspan="2" style="border-bottom:1px dashed">'.str_replace('[dir]','zdata/ztemp/files/'.session_id(),$this->get_message('howto')).'</td></tr>';
				$out .= '<tr><td>'.$this->get_message('docfilenames').'</td><td>
					<div id="fileQueue" style="float:left"><input type="file" name="uploadify" id="uploadify" /></div>
					<div style="float:left;vertical-align:middle"><button type="button" onclick="$(\'#uploadify\').uploadifyClearQueue();">'.$this->get_message('noUpload').'</button><br />
					<button type="button" onclick="$(\'#uploadify\').uploadifyUpload();">'.$this->get_message('upload').'</button></div>
					</td></tr>';
				$out .='<tr><td>'.$this->get_message('docqueue').'</td><td><select name="docqueue">';
			  $files=@scandir(self::$cms->cpath.'/ztemp/files/'.session_id().'/'); $files=($files===false?array():array_diff($files,array('.','..')));
				foreach ($files as $clef)
					$out .= '<option value="'.$clef.'">'.$clef.'</option>';
				$out.='</select> <input type="submit" name="delupload" value="'.$this->get_message('delUpload').'" '.(count($files)?'':'disabled').' /></td></tr>';
							// Afficher les rubriques
				$out .= '<tr><td>'.$this->get_message('docrub').'</td><td><select name="rub[]" multiple size=2 style="width:50%">';
				foreach (self::$cms->rubs as $clef => $valeur	)
					$out .= '<option '.(in_array($clef,$rub)?'selected':'').' value="'.$clef.'">'.$clef.'</option>';
				$out .= '</select> Vous pouvez choisir plusieurs rubriques</td></tr>';
							// Afficher les groupes pouvant modifier ce fichier
				$out .= '<tr><td>'.$this->get_message('docwrite').'</td><td><select name="groupW[]" multiple size=5 style="width:50%">';
				foreach (self::$cms->group as $clef => $valeur	)
					$out .= '<option '.(in_array($clef,$groupW)?'selected':'').' value="'.$clef.'">'.$clef.'</option>';
				$out .= '</select> <input type="submit" name="docwritegroup" value="'.$this->get_message('docwritegroup').'"/></td></tr>';
							// Afficher les groupes pouvant lire ce fichier
				$out .= '<tr><td>'.$this->get_message('docread').'</td><td><select name="groupR[]" multiple size=5 style="width:50%">';
				foreach (self::$cms->group as $clef => $valeur	)
					$out .= '<option '.(in_array($clef,$groupR)?'selected':'').' value="'.$clef.'">'.$clef.'</option>';
				$out .= '</select> <input type="submit" name="docreadall" value="'.$this->get_message('docreadall').'"/>';
				$out .= '<input name="save" type="hidden" value="'.self::$cms->args[1].'1" /></td></tr>';
				$out .= '<tr><td><input type="submit" name="submit" value="'.self::$cms->get_message('send').'" /></td><td><input type="submit" name="abort" value="'.self::$cms->get_message('abort').'" /></td></tr>';
		    break;
		  case 'new' :  // Ajouter un document
				$groupW = array_diff($_SESSION['zite_usergroup'],array('logon'));
				$groupR = array();
				$rub=array();
			case 'modif':
			  $readonly =((self::$cms->args[1]=='new')|| $zdocs->isDocAuthWrite($ident))?'':' disabled ';
//				if ($type=='img') $out.='<tr><td colspan="2"><img src="thumb.php/'.$ident.'" title="'.$desc.'" 	style="float:right" /></td></tr>';
				$out .= '<tr><td valign="top">'.$this->get_message('docident').'</td><td valign="top"><input name="ident" type="text" id="ident" value="'.$ident.'" size=40'.$readonly.'/>'.($type=='img'?'<img src="thumb.php/'.rawurlencode($ident).'" title="'.$desc.'" 	style="float:right" />':'').'<br />'.$this->get_message('docidentdesc').'</td></tr>';
//				$out .= '<tr><td>'.$this->get_message('docident').($type=='img'?'<img src="thumb.php/'.$ident.'" title="'.$desc.'" 	style="float:left" />':'').'</td><td valign="top"><input name="ident" type="text" id="ident" value="'.$ident.'" size=40'.$readonly.'/></td></tr><tr><td/><tr><td/><td>'.$this->get_message('docidentdesc').'</td></tr>';
				$out .= '<tr><td>'.$this->get_message('docfilename').'</td><td><input type="text" id="filename" name="filename" value="'.$filename.'" size=50 readonly />'.(empty($readonly)?'<input type="hidden" name="MAX_FILE_SIZE" value="'.self::$cms->get_data('upload_maxweight').'"><input type="file" id="file" name="file" value="'.$filename.'" size=1 onchange=auto_doctitle(this.form) />':'').'</td></tr>';
				$out .= '<tr><td></td><td>'.$this->get_message('docext').' <input name="ext" type="text" id="ext" value="'.$ext.'" size=8 readonly/> '.$this->get_message('doctype').' <input name="type" type="text" id="type" value="'.$type.'" size=8 readonly/></td></tr>';
				$out .= '<tr><td>'.$this->get_message('docdesc').'</td><td><input name="desc" type="text" id="desc" value="'.$desc.'" size=65'.$readonly.'/></td></tr><tr><td/><td>'.$this->get_message('docdescdesc').'</td></tr>';
				$out .= '<tr><td>'.$this->get_message('docauth').'</td><td><input name="auth" type="text" id="auth" value="'.$auth.'" size=20'.$readonly.'/> '.$this->get_message('docdate').'<input name="docdate" type="text" id="docdate" value="'.$docdate.'" size=15 readonly'.$readonly.' /></td></tr>';
							// Afficher les rubriques
				$out .= '<tr><td>'.$this->get_message('docrub').'</td><td><select name="rub[]" multiple size=2 style="width:50%"'.$readonly.'>';
				foreach (self::$cms->rubs as $clef => $valeur	)
					$out .= '<option '.(in_array($clef,$rub)?'selected':'').' value="'.$clef.'">'.$clef.'</option>';
				$out .= '</select> Vous pouvez choisir plusieurs rubriques</td></tr>';
							// Afficher les groupes pouvant modifier ce fichier
				$out .= '<tr><td>'.$this->get_message('docwrite').'</td><td><select name="groupW[]" multiple size=5 style="width:50%"'.$readonly.'>';
				foreach (self::$cms->group as $clef => $valeur	)
					$out .= '<option '.(in_array($clef,$groupW)?'selected':'').' value="'.$clef.'">'.$clef.'</option>';
				$out .= '</select> <input type="submit" name="docwritegroup" value="'.$this->get_message('docwritegroup').'"/></td></tr>';
							// Afficher les groupes pouvant lire ce fichier
				$out .= '<tr><td>'.$this->get_message('docread').'</td><td><select name="groupR[]" multiple size=5 style="width:50%"'.$readonly.'>';
				foreach (self::$cms->group as $clef => $valeur	)
					$out .= '<option '.(in_array($clef,$groupR)?'selected':'').' value="'.$clef.'">'.$clef.'</option>';
				$out .= '</select> <input type="submit" name="docreadall" value="'.$this->get_message('docreadall').'"/>';
				$out .= '<input name="save" type="hidden" value="'.self::$cms->args[1].'1" /></td></tr>';
				$out .= '<tr><td><input type="submit" name="submit" value="'.self::$cms->get_message('send').'" '.$readonly.'/></td><td><input type="submit" name="abort" value="'.self::$cms->get_message('abort').'" /></td></tr>';
		    break;
			case 'del':
			  if ($zdocs->isDocAuthWrite($ident)) {
					$out .= '<tr><td>'.$this->get_message('confirmdel').'</td></tr>';
					$out .= '<tr><td><ul>'.$this->get_message('docident').': <b>'.$ident.'</b></ul></td></tr>';
					$out .= '<tr><td><ul>'.$this->get_message('docfilename').': <b>'.$filename.'</b></ul></td></tr>';
					$out .= '<tr><td><ul>'.$this->get_message('docdesc').': <b>'.$desc.'</b></ul></td></tr>';
					$out .= '<tr><td colspan="2"><input type="submit" name="Submit" value="'.self::$cms->get_message('confirm').'" /><input name="save" type="hidden" value="del1" /><input name="docname" type="hidden" value="'.self::$cms->args[2].'" /><input type="submit" name="abort" value="'.self::$cms->get_message('abort').'" /></td></tr>';
			  }
			  break;
			}
	$out.='</table>';
	if (isset($_POST['Action'])&&isset($_POST['docsident'])) {
		$out.='<table class="ztable">';
		switch ($_POST['actionname']) {
		  case 'delall' :
				$out .= '<tr><td colspan="4">'.$this->get_message('confirmdelall').'</td></tr><tr>';
				$out .= '<td width="5%"></td><td><u>'.$this->get_message('docident').'</u></td>';
						$out .= '<td><u>'.$this->get_message('docfilename').'</u></td>';
						$out .= '<td><u>'.$this->get_message('docdesc').'</u></td></tr>';
				foreach ($_POST['docsident'] as $ident) {
			  	if ($zdocs->isDocAuthWrite($ident)) {
						$out .= '<td width="5%"></td><td><b>'.$ident.'</b></td>';
						$out .= '<td><b>'.$zdocs[$ident][cDocFilename].'</b></td>';
						$out .= '<td><b>'.$zdocs[$ident][cDocDesc].'</b></td></tr>';
						$out .='<input name="docsident[]" type="hidden" value="'.$ident.'" />';
					}
			  }
				$out .= '<tr><td colspan="4"><input type="submit" name="Submit" value="'.self::$cms->get_message('confirm').'" /><input name="save" type="hidden" value="delall1" /><input type="submit" name="abort" value="'.self::$cms->get_message('abort').'" /></td></tr>';
        $show_listdoc=false;
				break;
			case 'setall' :
				$out .= '<tr><td colspan="3">'.$this->get_message('setalltitle').'</td></tr><tr>';
				$out .= '<tr><td colspan="3">'.$this->get_message('setalldocs').'</td></tr><tr>';
				//$out .= '<td width="5%"></td><td><u>'.$this->get_message('docident').'</u> ('.$this->get_message('docdesc').')</td></tr>';
				foreach ($_POST['docsident'] as $ident) {
			  	if ($zdocs->isDocAuthWrite($ident)) {
						$out .= '<td width="5%"></td><td colspan="2"><b>'.$ident.'</b> ('.$zdocs[$ident][cDocDesc].')</td></tr>';
						$out .='<input name="docsident[]" type="hidden" value="'.$ident.'" />';
					}
			  }
			  $out.='<tr><td colspan="3">'.$this->get_message('setalldesc').'</td></tr>';
//
							// Afficher les rubriques
				$out .= '<tr><td>'.$this->get_message('docrub').'</td><td><select name="rub[]" multiple size=2 style="width:50%">';
				foreach (self::$cms->rubs as $clef => $valeur	)
					$out .= '<option '.(in_array($clef,$rub)?'selected':'').' value="'.$clef.'">'.$clef.'</option>';
				$out .= '</select> Vous pouvez choisir plusieurs rubriques</td></tr>';
							// Afficher les groupes pouvant modifier ce fichier
				$out .= '<tr><td>'.$this->get_message('docwrite').'</td><td><select name="groupW[]" multiple size=5 style="width:50%">';
				foreach (self::$cms->group as $clef => $valeur	)
					$out .= '<option '.(in_array($clef,$groupW)?'selected':'').' value="'.$clef.'">'.$clef.'</option>';
				$out .= '</select> <input type="submit" name="docwritegroup" value="'.$this->get_message('docwritegroup').'"/></td></tr>';
							// Afficher les groupes pouvant lire ce fichier
				$out .= '<tr><td>'.$this->get_message('docread').'</td><td><select name="groupR[]" multiple size=5 style="width:50%">';
				foreach (self::$cms->group as $clef => $valeur	)
					$out .= '<option '.(in_array($clef,$groupR)?'selected':'').' value="'.$clef.'">'.$clef.'</option>';
				$out .= '</select> <input type="submit" name="docreadall" value="'.$this->get_message('docreadall').'"/>';
//
			  
				$out .= '<tr><td colspan="3"><input type="submit" name="Submit" value="'.self::$cms->get_message('send').'" /><input name="save" type="hidden" value="setall1" /><input type="submit" name="abort" value="'.self::$cms->get_message('abort').'" /></td></tr>';
        $show_listdoc=false;
			  break;
		}
		$out.='</table>';
	}
		
						// grer le formulaire de base: la liste des documents
	if ($show_listdoc) {
			// Afficher la barre de tri
		$out .= '<table class="ztable" '.($this->getOption('showsortbar')?'':'style="display:none"').' >';
		$out .= '<tr><td colspan="2">'.$this->get_message('tri')
					.'<input type="radio" name="tri"  id="rb0" value="0"'.($tridoc==0?' checked':'').' />'.$this->get_message('tri0')
					.'<input type="radio" name="tri"  id="rb7" value="7"'.($tridoc==7?' checked':'').' />'.$this->get_message('doctype')
					.'<input type="radio" name="tri"  id="rb3" value="3"'.($tridoc==3?' checked':'').' />'.$this->get_message('docdesc')
					.'<input type="radio" name="tri"  id="rb2" value="2"'.($tridoc==2?' checked':'').' />'.$this->get_message('docrub')
					.'<input type="radio" name="tri"  id="rb4" value="4"'.($tridoc==4?' checked':'').' />'.$this->get_message('docauth')
					.'<input type="radio" name="tri"  id="rb8" value="8"'.($tridoc==8?' checked':'').' />'.$this->get_message('docdate');
		$out .= '  <input type="submit" name="updown" value="'.($updown==1?'&uarr;':'&darr;').'"/><input type="hidden" name="asc" value="'.$updown.'" /> <input type="submit" id="tridoc" name="tridoc" value="'.$this->get_message('sort').'"/></td></tr>';
		$out .= '</table>';
		$out .= '<input type="hidden" id="trijs" name="trijs" value="0" />';//</form>';
			//
	self::$cms->content['js'].='
			<script language="JavaScript" type="text/javascript">
					function getsupport (val){
						document.getElementById("rb"+val).checked=true;
						document.getElementById("trijs").value="1";
						document.formdocs.submit() ;}
					function setallcheck(obj){
						var val = obj.checked;
					  form = document.formdocs;
	  				inputs = form.getElementsByTagName("input");
					  for(i=0 ; i<inputs.length ; i++){
					    if(inputs[i].type=="checkbox" && inputs[i].name=="docsident[]"){
								inputs[i].checked=val;
					    }
						}
					}
						</script>';
			// Afficher la barre de filtrage
		$out .= '<table class="ztable" '.($this->getOption('showfilterbar')?'':'style="display:none"').' >';
		$out .= '<tr><td>'.$this->get_message('filter').'</td><td>'
					.'<input type="radio" name="filterdoc"  id="rbf0" value="0"'.($filterdoc==0?' checked':'').' />'.$this->get_message('tri0')
					.'<input type="radio" name="filterdoc"  id="rbf7" value="7"'.($filterdoc==7?' checked':'').' />'.$this->get_message('doctype')
					.'<input type="radio" name="filterdoc"  id="rbf3" value="3"'.($filterdoc==3?' checked':'').' />'.$this->get_message('docdesc')
					.'<input type="radio" name="filterdoc"  id="rbf2" value="2"'.($filterdoc==2?' checked':'').' />'.$this->get_message('docrub')
					.'<input type="radio" name="filterdoc"  id="rbf4" value="4"'.($filterdoc==4?' checked':'').' />'.$this->get_message('docauth')
					.'<input type="radio" name="filterdoc"  id="rbf8" value="8"'.($filterdoc==8?' checked':'').' />'.$this->get_message('docdate');
		$out.='</td></tr><tr><td>sur la valeur</td><td><input type="text" name="filterval" id="filterval" size="20" value="'.$filterval.'" />';
		$out .= '  <input type="submit" id="filter" name="filter" value="'.$this->get_message('filter').'"/></td></tr>';
		$out .= '</table>';
								// Afficher la liste de tous les documents
				$out .= '<div style="overflow:auto"><table class="ztable">';
				$carupdown = '<font size=+1> '.($updown==1?'&uarr;':'&darr;').'</font>';//plus lisible
				$out .= '<thead><tr class="headcolor" style="cursor:pointer;text-align:center" title="'.$this->get_message('sorthint').'">'.
								'<td><input type="checkbox" name="docsallcheck" onclick="javascript:setallcheck(this)" title="'.$this->get_message('docsallcheck').'"/></td><td></td><td></td>'.
								'<td onclick="javascript:getsupport(7)"><b>'.$this->get_message('doctype').($tridoc==7?$carupdown:'').'</b></td>'.
								'<td onclick="javascript:getsupport(3)"><b>'.$this->get_message('docdesc').($tridoc==3?$carupdown:'').'</b></td>'.
								'<td onclick="javascript:getsupport(2)"><b>'.$this->get_message('docrub').($tridoc==2?$carupdown:'').'</b></td>'.
								'<td onclick="javascript:getsupport(4)"><b>'.$this->get_message('docauth').($tridoc==4?$carupdown:'').'</b></td>'.
								'<td onclick="javascript:getsupport(8)"><b>'.$this->get_message('docdate').($tridoc==8?$carupdown:'').'</b></td>'.
								'<td style="cursor:default"><b>'.$this->get_message('docwrite').'</b></td>'.
								'<td style="cursor:default"><b>'.$this->get_message('docread').'</b></td><td></td></tr></thead>';
				$i=0;
				$zdocsR->setfilter($filterdoc,$filterval);
				$zdocsR->sort($tridoc,$updown);
				foreach ($zdocsR as $clef => $doc ) {
					$out .= '<tr class="'.(++$i%2 ? 'oddcolor' : 'evencolor').'">'.
									'<td align=center>'.($zdocs->isDocAuthWrite($clef)?'<input type=checkbox name="docsident[]" value="'.$clef.'" />':'').'</td>'.
									'<td align=center><a href="view.php/'.rawurlencode($clef).'" title="'.$this->get_message('zoom').'" target="_blank"><img src=deco/z1.png /></a></td><td align=center><a href="'.self::$cms->base.'selectdoc|modif|'.rawurlencode($clef).'" title="'.$this->get_message('modif').'"><img src=deco/edit.png /></a></td>'.
									'<td align=center>'.$doc[cDocType].'</td>'.
									'<td style="padding-left:5px"><a href="'.self::$cms->base.'selectdoc|modif|'.rawurlencode($clef).'">'.$doc[cDocDesc].'</a></td>'.
									'<td align=center><a href="'.self::$cms->base.'selectdoc|modif|'.rawurlencode($clef).'">'.arrayToString($doc[cDocRub]).'</a></td>'.
									'<td align=center><a href="'.self::$cms->base.'selectdoc|modif|'.rawurlencode($clef).'">'.$doc[cDocAuth].'</a></td>'.
									'<td align=center><a href="'.self::$cms->base.'selectdoc|modif|'.rawurlencode($clef).'">'.$doc[cDocDate].'</a></td>';
					$out .= '<td align=center><a href="'.self::$cms->base.'selectdoc|modif|'.rawurlencode($clef).'|'.(arrayToString($doc[cDocWrite])).'"><img src="deco/kw'.($doc[cDocWrite]?'1': '0').'.png" title="'.arrayToString(array_unique(array_merge($doc[cDocWrite],array('admin')))).'"/></a></td>'.
									'<td align=center><a href="'.self::$cms->base.'selectdoc|modif|'.rawurlencode($clef).'|'.(arrayToString($doc[cDocRead])).'"><img src="deco/kr'.($doc[cDocRead]?'1': '0').'.png" title="'.($doc[cDocRead]?arrayToString($doc[cDocRead]):$this->get_message('grpreadall')).'"/></a></td>'.
									'<td align=center>'.($zdocs->isDocAuthWrite($clef)?'<a href="'.self::$cms->base.'selectdoc|del|'.rawurlencode($clef).'" title="'.$this->get_message('del').'"><img src="deco/e1.png" /></a>':'<img src="deco/e0.png" />').'</td></tr>';
				}
				$out.='</table>';
				$out .= '</div>'.$this->get_message('comment');
				if (1==1) {// finir
				  $out.='<br /><select name="actionname"><option value="">Choisir une action...</option><option value="delall">Supprimer</option><option value="setall">Affecter</option></select> <input type="submit" name="Action" value="'.self::$cms->get_message('confirm').'" />';
				}
	}//show_listdocs
	$out .= '</form>';
	return $out;
}
}
?>