<?php
/*
module:	Gestion des thmes
Copyright Jean-Paul GIAUSSERAND 2009-2011
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.7  07/09/2011  Simulation fonction "imagefilter" pour Free et autre
	v1.6  03/02/2011  Possibilit de modifier un thme de prod ou de test
	v1.5  05/01/2011  Rationalisation des icones - Amlioration css
	v1.4  28/02/2010  Fiabilisation du module - premire release publique
	v1.3  11/02/2010  Notion de thmes de production et de dmonstration
	v1.2  10/01/2010  uniformisation du fonctionnement
	v1.1  15/12/2009  Gestion des paramtres de configuration
	v1.0	01/12/2009	Cration du module
*/
class Tskin extends Tmodule {
	static $skindir = 'skin/';  // O trouver le rpertoire des skins
		// Crer le fichier cms.css
	function makecmscss(&$skinconfig) {
	  $cmscss ='';
 	  if (isset($skinconfig['menu_left'])&&$skinconfig['menu_left']) {
			$cmscss .= "#oppside {float:right;}\n#side {float:left;}";
		} else { $cmscss .= "#oppside {float:left;}\n#side {float:right;}"; }
		if (isset($skinconfig['page_width'])&&($skinconfig['page_width']>0)) {
			$cmscss.='#page {width:'.$skinconfig['page_width'].'px}';
			$cmscss.='#top {width:'.$skinconfig['page_width'].'px}';
			$cmscss.='#mid {width:'.$skinconfig['page_width'].'px}';
			$cmscss.='#bot {width:'.$skinconfig['page_width'].'px}';
		}
		if (isset($skinconfig['side_width'])&&($skinconfig['side_width']>0)) {
			$cmscss.='#side {width:'.$skinconfig['side_width'].'px}';
		}
		if (isset($skinconfig['oppside_width'])&&($skinconfig['oppside_width']>0)) {
			$cmscss.='#oppside {width:'.$skinconfig['oppside_width'].'px}';
		}
		$cmscss.='#page{overflow:auto;} #mid{clear:both;display:block;} #side{ display:block;} #main{overflow:auto;min-width:1px;display:block;} #top{clear:both;} #break{clear:both;} #bot{clear:both;}';
	  return $cmscss;
	}
	function makebasecss($basetheme,$skinname,&$skinconfig,$isprod=false){
		function html2rgb($color) {//Conversion html->rvb
		  if (substr($color,0,1)=="#") $color=substr($color,1,6);
		  $tablo[0] = hexdec(substr($color, 0, 2));
		  $tablo[1] = hexdec(substr($color, 2, 2));
		  $tablo[2] = hexdec(substr($color, 4, 2));
		  return $tablo;
		}
		  // Construire le fichier de style  partir du modle
  	$basecss=file_get_contents($basetheme.$skinname.'/base.css');
    $basecss=@str_ireplace(array('[basecolor]','[pagecolor]','[backcolor]','[headcolor]','[oddcolor]','[evencolor]'),array($skinconfig['basecolor'],$skinconfig['pagecolor'],$skinconfig['backcolor'],$skinconfig['headcolor'],$skinconfig['oddcolor'],$skinconfig['evencolor']) , $basecss);
		$basecss=@str_ireplace(array('[deco]'),array($isprod?'deco':'../_deco/std'),$basecss);
    file_put_contents($basetheme.$skinname.'/'.$skinname.'.css',$basecss,LOCK_EX);
			// personnaliser les couleurs de certains lments graphiques
		if (isset($skinconfig['basecolor'])&&(file_exists($basetheme.$skinname.'/deco/basecolor'))) {
			$dirdeco = $basetheme.$skinname.'/deco/';
			$rgb2=html2rgb($skinconfig['basecolor']);
        // Explorer la liste des lments personnalisables
			$decolist=array_diff(scandir($dirdeco.'/basecolor'),array('.','..'));
			foreach ($decolist as $clef) {
				$img = stripos($clef,'.gif')? imagecreatefromgif($dirdeco.'/basecolor/'.$clef):imagecreatefrompng($dirdeco.'/basecolor/'.$clef);
				if (function_exists('imagefilter')&&(phpversion()>='5.2.5')) {
		    	imagefilter($img,IMG_FILTER_COLORIZE,$rgb2[0],$rgb2[1],$rgb2[2],0x00);
				} else {
				  Tmodule::tools('imagefilter_');
		    	imagefilter_($img,IMG_FILTER_COLORIZE,$rgb2[0],$rgb2[1],$rgb2[2],0x00);
				}
		    imagepng($img,$dirdeco.$clef);
		    imagedestroy($img);
			}
		}
	}
	  //
	  //
	  //
	function makeconfigfield($skin,$resetskin=false){
		$themename = isset($_SESSION['skin_demo'])?basename($skin,'.css'):'';
		$basetheme = isset($_SESSION['skin_demo'])?self::$skindir:Tmodule::$cms->cpath;
	  $skinconfig=file_exists($basetheme.$themename.'/skin.ini')?(array)parse_ini_file($basetheme.$themename.'/skin.ini', true):array();
	  $skinoption=(array)parse_ini_file($basetheme.$themename.'/skin.opt', true);
	  $out='';
		self::$cms->content['js'].='<script type="text/javascript" src="js/jscolor/jscolor.js"></script>';
	  foreach($skinoption as $k => $vopt) {
	    $opt=explode(';',$vopt);
	    if (!empty($opt[0])) {
	    $v=(isset($skinconfig[$k])&&!$resetskin)?$skinconfig[$k]:$opt[1];
	    $out .= '<tr><td>'.(!empty($opt[1])?'<strong>'.$k.'</strong> : ':'').$this->get_message($k.'_desc',false).'</td><td>';
			if ($opt) {
				switch($opt[0]) {
					case 'bool':
				  	$opt[2]='0:1';
			  	case 'list':
						$out.='<select name="_'.$k.'">';
						$list=explode(':',$opt[2]);
						foreach ($list as $k1 => $v1) {
  	    			$out.='<option value="'.$v1.'"'.($v1==$skinconfig[$k]?' selected ':'').'>'.$this->get_message($k.'_'.$v1);
						}
						$out.='</select> '.$this->get_message($k.'_desc2',false);
			  	  break;
			  	case 'int':
			  		$out .= '<input name="_'.$k.'" type="text" value="'.$v.'" style="width:60px;text-align:right" /> '.$this->get_message($k.'_desc2',false);
			  	  break;
					case 'read':
/* voir*/			  		$out .= '<input name="_'.$k.'" type="text" value="'.$v.'" style="width:60px;text-align:right" readonly/> '.$this->get_message($k.'_desc2',false);
					  break;
					case 'label':
					  break;
					case 'color':
				  	$out .= '<input class="color {hash:true,caps:false}" name="_'.$k.'" type="text" id="'.$k.'" value="'.$v.'" style="text-align:left" size="10" /> <i>'.$this->get_message('color',false).'</i> ';
					  break;
					case 'none':
					 	$out .= '<input name="_'.$k.'" type="text" value="inactif" readonly/>';
					  break;
				 	default: $out .= '<input name="_'.$k.'" type="text" value="'.$v.'" style="width:80%" '.($opt[0]=='read'?' readonly ':'').'/>';
				}
			} else $out .= '<input name="_'.$k.'" type="text" value="'.$v.'" style="width:80%" />';//impossible depuis changement
		$out .='</td></tr>';
		}
		}
		return $out;
	}
		//
		//
		//
//args: 0=skin(modulename), 1=nom_du_theme, 2=select|demo|
	function dojob($opt="") {
		parent::dojob();
//		print_r(self::$cms->args);
   	$basetheme = self::$skindir;
  	$skinname = isset(self::$cms->args[1])?self::$cms->args[1]:(isset($_SESSION['skin_demo'])?basename($_SESSION['skin_demoname'],'.css'):basename(self::$cms->config['files_styleskin'],'.css'));
		//
		if (!isset(self::$cms->args[2])) self::$cms->args[2]='';
		//
		if (isset($_POST['resetskin'])){
		  //bouton: remettre les paramtres par dfaut du skin en cours de test
		} elseif (isset($_POST['aborttest'])) {
			// Bouton: Sortir du mode test et revenir au thme de production
			unset($_SESSION['skin_demo']);
			unset($_SESSION['skin_demodir']);
			unset($_SESSION['skin_demoname']);
	  	$skinname = basename(self::$cms->config['files_styleskin'],'.css');
	  	self::$cms->args[2]='';
		} elseif (isset($_POST['goprod'])) {
			//Bouton: Passer le thme de test en production
	 	  $skinconfig=(array)parse_ini_file($basetheme.$skinname.'/skin.ini', true);
			$this->makebasecss($basetheme,$skinname,$skinconfig,true);
		    // Copier les fichiers de bases
      copy($basetheme.$skinname.'/base.css', self::$cms->ipath.'/base.css');
      copy($basetheme.$skinname.'/cms.css', self::$cms->ipath.'/cms.css');
      copy($basetheme.$skinname.'/'.$skinname.'.css', self::$cms->ipath.'/'.$skinname.'.css');
      copy($basetheme.$skinname.'/skin.ini', self::$cms->cpath.'/skin.ini');
      copy($basetheme.$skinname.'/skin.opt', self::$cms->cpath.'/skin.opt');
        // Copier les icones et images standard zitePLUS
			$decolist=array_diff(scandir(self::$skindir.'/_deco/std'),array('.','..'));
			foreach ($decolist as $clef) {
				if (is_file(self::$skindir.'_deco/std/'.$clef)) {
			     copy(self::$skindir.'_deco/std/'.$clef, self::$cms->ipath.'/deco/'.$clef);
				}
			}
        // Copier les icones et images de bases du thme
			$decolist=array_diff(scandir($basetheme.$skinname.'/deco'),array('.','..'));
			foreach ($decolist as $clef) {
				if (is_file($basetheme.$skinname.'/deco/'.$clef)) {
			     copy($basetheme.$skinname.'/deco/'.$clef, self::$cms->ipath.'/deco/'.$clef);
				}
			}
				// Sauver le nouveau thme
	    self::$cms->config['files_styleskin'] = $skinname.'.css';
			self::$cms->writeconfig(self::$cms->cpath.'/config.ini', self::$cms->config);
			  // Sortir du mode test (si actif)
			unset($_SESSION['skin_demo']);
			unset($_SESSION['skin_demodir']);
			unset($_SESSION['skin_demoname']);
		} elseif (isset($_POST['abortParam'])) {//ne pas valider les modifs du thme
		  self::$cms->args[2]='';
		}	elseif (isset($_POST['saveParam'])) {//Sauvegarder les changements des paramtres de configurations
				// Passage du thme en dmo
		  if ((!isset($_SESSION['skin_demo'])&&is_dir($basetheme.$skinname))) {
				$_SESSION['skin_demo']= true;
				$_SESSION['skin_demodir']= $basetheme.$skinname;
				$_SESSION['skin_demoname']= $skinname;
			}
			if (isset($_SESSION['skin_demo'])) {
    	  	// Mise  jour du fichier skin.ini du skin
		 	  $skinconfig=(array)parse_ini_file($basetheme.$skinname.'/skin.ini', true);
	 		  foreach ($_POST as $key => $value) {
		 	    if ($key[0]=='_') {
		 	      $skinconfig[ltrim($key,'_')]=$value;
					}
				}
				self::$cms->writeconfig($basetheme.$skinname.'/skin.ini', $skinconfig);
			  	// Mise  jour du fichier cms.css du thme
				$cmscss=$this->makecmscss($skinconfig);
			  if (is_dir($basetheme.$skinname)) {
  	  		file_put_contents($basetheme.$skinname.'/cms.css',$cmscss,LOCK_EX); // Ecrire le nouveau style cms
					$this->makebasecss($basetheme,$skinname,$skinconfig,false);
				}
			} else {
			  	// Si le thme est en production, mise  jour du fichier cms.css de production
		    	file_put_contents(self::$cms->ipath.'/'.'cms.css',$cmscss,LOCK_EX); // Ecrire le nouveau style cms
					$this->makebasecss(self::$cms->ipath.'/',$skinname,$skinconfig,true);
			}
		} elseif ((isset(self::$cms->args[2])&&(self::$cms->args[2]=='demo'))||isset($_POST['editprod'])||isset($_POST['editskin'])	) {
			if (isset($_POST['editprod'])) {
				if (!is_dir($basetheme.$skinname)) mkdir($basetheme.$skinname);
				if (!is_dir($basetheme.$skinname.'/deco')) mkdir($basetheme.$skinname.'/deco');
				if (!is_dir($basetheme.$skinname.'/deco/basecolor')) mkdir($basetheme.$skinname.'/deco/basecolor');
    	  copy(self::$cms->cpath.'/skin.ini', $basetheme.$skinname.'/skin.ini');  // Prendre les fichiers de prod
	    	copy(self::$cms->ipath.'/'.(file_exists(self::$cms->ipath.'/base.css')&&(filesize(self::$cms->ipath.'/base.css')>0)?'base.css':self::$cms->config['files_styleskin']), $basetheme.$skinname.'/base.css');
	    		// analyser le fichier base.css pour voir s'l faut rapatrier des icnes de la production (mthode gros bourrin)
	    	$mycss=file($basetheme.$skinname.'/base.css');
	    	foreach($mycss as $licss) if (stripos($licss,'url')!==false) if (($s=preg_replace('@.*url.*\( *(deco/.+) *\).*@is','$1', $licss))!==$licss) {
			  	copy(self::$cms->ipath.'/'.$s , $basetheme.$skinname.'/'.$s); // il faudrait ne pas copier les fichiers dj copi (fichier cit plusieurs fois dans le css)
				}
				//header('Location: '.self::$cms->base."skin|$skinname|demo");            // Aller en dmo (provisoire)
			}
			self::$cms->args[2]='demo';
			//Passage en mode test de thme
		  if (is_dir($basetheme.$skinname)) {
				$_SESSION['skin_demo']= true;
				$_SESSION['skin_demodir']= $basetheme.$skinname;
				$_SESSION['skin_demoname']= $skinname;
        $skinconfig=file_exists($basetheme.$skinname.'/skin.ini')?(array)parse_ini_file($basetheme.$skinname.'/skin.ini', true):array();
				if (empty($skinconfig)){// prendre les valeurs par dfaut du module
					$skinoption=$basetheme.$skinname.'/skin.opt'?(array)parse_ini_file($basetheme.$skinname.'/skin.opt', true):array();
//					print_r($skinoption);
					foreach($skinoption as $k => $vopt) {
  					$opt=explode(';',$vopt);
						if (!(isset($skinconfig[$k]) && strlen($skinoption[$k])) && ($opt[0]!='label')) $skinconfig[$k]=$opt[1];
					}
					self::$cms->writeconfig($basetheme.$skinname.'/skin.ini', $skinconfig);
				}
				$cmscss=$this->makecmscss($skinconfig);
  	 		file_put_contents($basetheme.$skinname.'/cms.css',$cmscss,LOCK_EX); // Ecrire le nouveau style cms
				$this->makebasecss($basetheme,$skinname,$skinconfig,false);
			}
		}
		// Lire valeur fichier de config :: makeconfigfield
// formulaire
	$out = '<form method="post" action="'.self::$cms->base.'skin|'.$skinname.'|'.self::$cms->args[2].'" enctype="multipart/form-data"><table class="ztable">';
	$out .= '<tr><td colspan="2"><center><h2>'.$this->get_message('title').'</h2></center></td></tr>';
	$out .= '<tr><td colspan="2">'.$this->get_message('titledesc').'</td></tr>';
//	$out .= '<tr><td align="left">'.count($theme).' Thmes disponibles</td><td align="right">'/*<a href="'.self::$cms->base.'user||new"><img src="deco/a.png" />Ajouter</a>*/.'</td></tr>';
	$out .= '</table><table class="ztable">';
	$out .= '<tr><td>Thme en cours : <b>'.$skinname.'</b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Type: <b>'.
					(isset($_SESSION['skin_demo'])?'Dmonstation':'Production &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<button type="submit" name="editprod" style="background-color:transparent;border:none;vertical-align:text-bottom;cursor:pointer;float:right"><img src="deco/edit.png" title="'.$this->get_message('editskin').'"/></button>').
					'</b></td>';
		$out.='<td>';
		if (isset($_SESSION['skin_demo'])) {
			$out.='<table>';
			$out.='<tr><td><input type="submit" name="editskin" value="'.$this->get_message('editskin').'"/></td></tr>';
			$out.='<tr><td><input type="submit" name="aborttest" value="'.$this->get_message('aborttest').'"/></td></tr>';
			$out.='<tr><td><input type="submit" name="goprod" value="'.$this->get_message('goprod').'"/></td></tr>';
			$out.='</table>';
		}
		$out.='</td></tr>';
	$out .= '</table><table class="ztable">';
	if (!empty(self::$cms->args[2])) {
//		$skinname=basename($skinname,'.css');
		$out .= '<tr><td colspan="2"><h3>'.$this->get_message('param').': '.strtoupper($skinname).'</h3></td></tr>';
		$out .= $this->makeconfigfield($skinname,isset($_POST['resetskin']));//self::$cms->config['files_styleskin']);
		$out .= '<tr><td colspan="2"><input type="submit" name="saveParam" value="'.self::$cms->get_message('submit').'" /><input type="submit" name="abortParam" value="'.self::$cms->get_message('abort').'" />'
						."<a href='".self::$cms->base."source_editor|skin|{$skinname}|base.css' ><button type='button' style='float:right'><img src='deco/edit.png'>{$this->get_message('editcss')}</button></a>"
						.'<input type="submit" name="resetskin" value="'.$this->get_message('resetskin').'" title="'.$this->get_message('resetskin_desc').'" style="float:right"/></td></tr>';
		$out .= '<tr><td colspan="2">'.$this->get_message('comment').'</td></tr></table></form>';
	}
		// lister tous les thmes disponibles
	$skindtaname = self::$cms->cpath.'/skin.dta';	$skindta = (file_exists($skindtaname)?(array)unserialize(@file_get_contents($skindtaname)):array()); $skindtachange=false;
	$out .= '<table class="ztable">';
	$out .= '<tr class="headcolor"><td align="center">'.$this->get_message('colselect').'</td><td>'.$this->get_message('colname').'</td><td>'.$this->get_message('coldesc').'</td><td>'.$this->get_message('colauth').'</td></tr>';
	$skinlist=array_diff(scandir($basetheme),array('.','..','_deco')); // 1 skin par rpertoire
	$i=0;foreach ($skinlist as $clef) {
	  if (strpos($clef,'zz')!==0 && is_dir($basetheme.$clef)) {
	    if (!isset($skindta[$clef])){
	      if (file_exists("$basetheme$clef/desc.ini")) {
	        $skindesc=@parse_ini_file("$basetheme$clef/desc.ini",true);
	        $skindta[$clef]=array($skindesc[$this->lang]['desc'],isset($skindesc[$this->lang]['comment'])?$skindesc[$this->lang]['comment']:'',isset($skindesc['author'])?$skindesc['author']:'');
				} else $skindta[$clef]=array($clef,'','');
			}
			$out .= '<tr class="'.(++$i%2 ? 'oddcolor' : 'evencolor').'">
					<td align="center"><a href="'.self::$cms->base.'skin|'.$clef.'|demo"><img src="deco/edit.png" /></a></td>
					<td><a href="'.self::$cms->base.'skin|'.$clef.'|demo">'.strtoupper($clef).'</a></td>
					<td>'.$skindta[$clef][0].'</td>
					<td title="'.$skindta[$clef][1].'">'.$skindta[$clef][2].(file_exists("$basetheme$clef/readme.txt")?" <a href='$basetheme$clef/readme.txt' target='_blank'> <img src='deco/pge1.png' /></a>":'').'</td>';
			$out.='</tr>';
		}
	}
	$out .= '</table>';
	return $out;
	}
}
?>
