<?php
/*
Classe: Gestion des documents
Copyright Jean-Paul GIAUSSERAND 2009-2011
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v2.1: Optimisation vitesse de traitement
	v2.0: Implmentation des interfaces
	v1.0: Cration de la classe
*/
// index du tableau = nom unique du document = url
define('cDocFilename',0);		// Nom du document sur le disque
define('cDocExt',1);				// extension du fichier
define('cDocRub',2);				// Rubrique
define('cDocDesc',3);       // Description du fichier (titre)
define('cDocAuth',4);				// Dernier utilisateur uploadant le fichier
define('cDocWrite',5);			// Droits de remplacer/supprimer le document
define('cDocRead',6);				// Droits de lecture du document
define('cDocType',7);				// Type du fichier: img/pdf/swf
define('cDocDate',8);  			// Date de cration du document ou de dernier changement
//
class Tdocs implements Iterator, Countable, ArrayAccess {
	protected static $docs; 	// Tous les documents: une seule instance
 	protected static $filename;
	//
	protected $docsR=array(); // table des documents accessibles par l'utilisateur en cours
	protected $kdocsR=false;  // Index lments en cours
	//
	protected $filterType=null;
	protected $filterVal=null;
	//
	function __construct($file=null,$type=null,$value=null) {
		if (!empty($type)) {
			$this->filterType=$type;
			$this->filterVal=(empty($value)||$type==0)?null:$value;
		  }
		if (empty($file)) {
		  $this->_init();
		} else {
			if (empty(self::$filename)) {
				self::$filename = $file;
				$this->refresh();
				} else $this->_init();
		}
	}
	public function setFilter($type,$value){
	  $this->filterType=$type;
	  $this->filterVal=(empty($value)||$type==0)?null:$value;
		$this->_init();
	}
	protected function _isFilter($ident){//Ant: $ident existe
		$ok=false;
		if (isset($this->filterVal)) {
			if (isset(self::$docs[$ident][$this->filterType])) {
				$s=self::$docs[$ident][$this->filterType];
			} else {
			 	$doc=$this->offsetGet($ident);
				$s=$doc[$this->filterType];
		  }
			if ($this->filterType==cDocRub) $s=implode(" ",$s);
			$ok=stripos($s,$this->filterVal)!==false;
		} else $ok=true;
		return $ok;
	}
		// Fonction interne pour dterminer la visibilit d'un document
	protected function _isDocAuth($docname) {
		if ($this->_isDoc($docname)
		 && ((isset($_SESSION['zite_admin'])&&($_SESSION['zite_admin']==2))
		 ||empty(self::$docs[$docname][cDocRead])
		 ||(isset($_SESSION['zite_usergroup'])&&(array_intersect(self::$docs[$docname][cDocRead],$_SESSION['zite_usergroup'])!= array()))
		 ||( (!empty(self::$docs[$docname][cDocWrite])) && (isset($_SESSION['zite_usergroup'])&&(array_intersect(self::$docs[$docname][cDocWrite],$_SESSION['zite_usergroup'])!= array()))))) {
			return true;
		} else return false;
	}
	protected function _init(){
		$this->docsR=array();
		foreach(array_keys(self::$docs) as $key){		  if ($this->_isDocAuth($key)&&$this->_isFilter($key)) {$this->docsR[]=$key;}		}
		$this->rewind();
	}
	function refresh() {
		self::$docs =  (array)unserialize(@file_get_contents(self::$filename));
		$this->_init();
	}
	protected function _isDoc($docname){
		return (!empty($docname) && array_key_exists($docname,self::$docs));
	}
	function isDoc($docname) {//une seule utilit: selectDoc =>  changer+protected ou tuiliser isDocAuth
		if (empty($docname) || !array_key_exists($docname,self::$docs)) {//voir si $this
		  return false;
		} else return true;
	}
	/*Interface Coutable*/
	public function count(){	  return count($this->docsR);	}
	/*Interface Iterator*/
	public function rewind(){		$this->kdocsR=reset($this->docsR);	}
	public function current(){	  return $this[$this->kdocsR];	}
	public function key(){	  return $this->kdocsR;	}
	public function next(){	  $this->kdocsR=next($this->docsR);	}
	public function valid() {	  return ($this->kdocsR!==false);	}
	/*Interface ArrayAccess*/
	public function offsetGet($key) {
	  if ($this->_isDocAuth($key)) {//in_array($key,$this->docsR)) {
			$doc = self::$docs[$key];
	   	$ext = pathinfo($key); $ext = strtolower($ext['extension']); // bof:  optimiser
		  if (!isset($doc[cDocDesc])) {
		    $doc[cDocDesc]=basename($key,'.'.$ext);
		  }
	  	if (!isset($doc[cDocFilename])) $doc[cDocFilename]=strtolower($key);
	  	if (!isset($doc[cDocRub])) $doc[cDocRub]=array();
	  	if (!isset($doc[cDocRead])) $doc[cDocRead]=array();
	  	if (!isset($doc[cDocWrite])) $doc[cDocWrite]=array();
	  	if (!isset($doc[cDocAuth])) $doc[cDocAuth]='admin';
	  	if (!isset($doc[cDocExt])) $doc[cDocExt]=$ext;
	  	return $doc;
		} else { return null;};
	}
	public function offsetExists($key) {
		return $this->_isDocAuth($key);
	}
	public function offsetSet($key, $value) {}
	public function offsetUnset($key) {}
	//
	public function sort($tridoc=cDocDesc,$asc=true){
		global $prov;
		global $prov2;
		$prov=$this;$prov2=self::$docs;
		$ab=$asc?'$a, $b':'$b, $a';
		if ($tridoc==0) {}
		elseif ($tridoc==cDocDate) {uasort($this->docsR, create_function($ab, 'global $prov; return strcmp(substr($prov[$a]['.$tridoc.'],6,4).substr($prov[$a]['.$tridoc.'],3,2).substr($prov[$a]['.$tridoc.'],0,2), substr($prov[$b]['.$tridoc.'],6,4).substr($prov[$b]['.$tridoc.'],3,2).substr($prov[$b]['.$tridoc.'],0,2));'));}
		elseif ($tridoc==cDocRub) {uasort($this->docsR, create_function($ab, 'global $prov; return strcmp(implode(" ",$prov[$a]['.$tridoc.']), implode(" ",$prov[$b]['.$tridoc.']));'));}
		elseif ($tridoc==cDocDesc) {uasort($this->docsR, create_function($ab, 'global $prov;global $prov2;  $aa=empty($prov2[$a][cDocDesc])?$a:$prov[$a][cDocDesc]; $bb=empty($prov2[$b][cDocDesc])?$b:$prov[$b][cDocDesc];  return strcmp(strtolower($aa), strtolower($bb));'));}
		else uasort($this->docsR, create_function($ab, 'global $prov; return strcmp(strtolower($prov[$a]['.$tridoc.']), strtolower($prov[$b]['.$tridoc.']));'));
		$prov=null;$prov2=null;
		$this->rewind();
	}
	//
	function getValues($index, $val) {//091-fonction obsolte => suppression de tous les source en cours
	  if ($this->_isDocAuth($index)) {
	    if (isset(self::$docs[$index][$val])) {
				return self::$docs[$index][$val];
			} else {
				 switch($val) {
		      case cDocDesc :
		      	$ext = pathinfo($index); $ext = strtolower($ext['extension']); // bof:  optimiser
		        return basename($index,'.'.$ext);
		        break;
	  	    case cDocFilename:
	  	      return strtolower($index);
						break;
					case cDocRub :
					case cDocWrite:
					case cDocRead:
					  return array();
						break;
					case cDocAuth:
					  return 'admin';
						break;
					case cDocExt:
		      	$ext = pathinfo($index); $ext = strtolower($ext['extension']); // bof:  optimiser
					  return $ext;
						break;
	  	    default : return null;
	  	    }
			}
		} return null;
	}
//
function isDocAuth($docname) {
	return 	$this->_isDocAuth($docname);//provisoire
}
}//tdocs
//
class Tdocsimage extends Tdocs {//exprimental
	protected function _isdocAuth($docname) {
		return parent::_isdocAuth($docname) && ($this[$docname][cDocType]=='img');
	}
}
?>
