<?php
/*
Classe: Gestion des documents
Copyright Jean-Paul GIAUSSERAND 2009-2010
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v2.0: Implmentation des interfaces
	v1.2: utilisation isDocAuthWrite dans les fonctions internes de Tdocsadmin
	v1.1: Ajout gestion des vignettes
	v1.0: Cration de la classe
*/
require_once dirname(__FILE__).'/tdocs.php';
	//
class Tdocsadmin extends Tdocs {
	protected static $cms;
	public static function set_cms(zite $zp) {	  self::$cms = $zp;	}
	//
	protected function _isDocAuth($docname) {
		return ($this->_isDoc($docname)&&(($_SESSION['zite_admin']==2)||( (!empty(self::$docs[$docname][cDocWrite])) &&  array_intersect(self::$docs[$docname][cDocWrite],$_SESSION['zite_usergroup'])!= array())));
	}
	public function save(){//doit-tre protected ?
		$i=@file_put_contents(self::$filename, serialize(self::$docs), LOCK_EX );
		$this->_init();
		return $i;
	}
	/*Interface ArrayAccess*/
	public function offsetSet($key, $doc) {
		if (!$this->_isDoc($key)||$this->_isDocAuth($key)) {
		  $this->_compactDoc($key,$doc);
			self::$docs[$key] = $doc;
			if (!in_array($key,$this->docsR)) $this->docsR[]=$key;
		}
	}
	public function offsetUnset($key) {
		if ($this->_isDocAuth($key))	{
			unset(self::$docs[$key]);
//			unset($this->docsR[$key]);// vrifier  //			$this->_init();
		}
  }
  /**/
  protected function _compactDoc($key,&$doc){
    $change=false;
		$ext = pathinfo($key); $ext = strtolower($ext['extension']);
		$desc = basename($key,'.'.$ext);
		$filename = strtolower($key);
		if (isset($doc[cDocFilename])&&(strtolower($doc[cDocFilename])==$filename)) {unset($doc[cDocFilename]);$change=true;}
		if (isset($doc[cDocDesc])&& ($doc[cDocDesc]==$desc)) {unset($doc[cDocDesc]);$change=true;}
		if (isset($doc[cDocWrite]) && in_array('admin',$doc[cDocWrite])) $doc[cDocWrite]=array_diff($doc[cDocWrite],array('admin'));
		if (isset($doc[cDocWrite])&&($doc[cDocWrite]==array())) {unset($doc[cDocWrite]);$change=true;}
		if (isset($doc[cDocRead])&&($doc[cDocRead]==array())) {unset($doc[cDocRead]);$change=true;}
		if (isset($doc[cDocRub])&&($doc[cDocRub]==array())) {unset($doc[cDocRub]);$change=true;}
		if (isset($doc[cDocAuth])&&($doc[cDocAuth]=='admin')) {unset($doc[cDocAuth]);$change=true;}
		if (isset($doc[cDocExt])&&($doc[cDocExt]==$ext)) {unset($doc[cDocExt]);$change=true;}
		return $change;
	}
  /**/
	public function isDocAuthWrite($docname) {
		if ($this->_isDoc($docname) && (($_SESSION['zite_admin']==2)||(array_intersect((array)$this[$docname][cDocWrite],$_SESSION['zite_usergroup'])!= array()))) {
			return true;
		} else return false;
	}
	//
	function removeDoc($docname) {
	  $this->refresh();
	  if ($this->isDocAuthWrite($docname)) {//v091
			unset(self::$docs[$docname]);
			$this->save();
		}
	}
	function updateDoc($docname, $filename,$ext,$rub,$desc,$auth,$groupW,$groupR,$type,$date) {
	  $this->refresh();
	  $this[$docname] = array($filename,$ext,$rub,$desc,$auth,$groupW,$groupR,$type,$date);
		$this->save();
		$this->makethumb($docname);
	}
	function verifdoc(&$doc,&$ident,&$ext,&$rub,&$desc,&$auth,&$groupW,&$groupR,&$type,&$date) {
		$ident = trim(stripslashes($ident));
		$doc = trim(stripslashes($doc));
		$ext = pathinfo($doc); $ext = strtolower($ext['extension']);
	  switch($ext) {
	    case 'jpg': case 'jpe': case 'jpeg': case 'png': case 'gif':
	      $type = 'img';
	      break;
			case 'pdf': case 'txt':
			  $type = $ext;
			  break;
			case 'zip': case 'Zz' : case 'tar' : case 'rar' :
			  $type = 'zip';
			  break;
			case 'swf': case 'mov' : case 'flv' : case 'wmv': case 'mkv':
			case 'dcr': case 'qt': case 'mpg': case 'mp4': case 'mpeg': case 'avi': case 'wm':
			case 'asf': case 'asx': case 'wmx': case 'wvx': case 'rm': case 'ra': case 'ram':
			  $type = 'film';
			  break;
			case 'mp3':
			  $type='son';
			  break;
			default :
			  $type = '';
		}
		if (empty($ident)) {
		  $ident=$doc;
		}
		if (empty($desc)) {
		  $desc = basename($ident,'.'.$ext);
		}
		if (in_array('admin',$groupW)) {
		  $groupW=array_diff($groupW,array('admin'));
		}
		if (empty($auth))	$auth = $_SESSION['zite_user'];
		if (empty($date)) $date = @date("d/m/Y");
	}
	function makethumb($ident,$force=false) {
		if(isset(self::$cms)) {
			$dirdoc = self::$cms->dpath.'/';
		} else {
		  $dirdoc = dirname(__FILE__).'/../zdata/zdocs/';//substr($_SERVER['SCRIPT_FILENAME'],0,stripos($_SERVER['SCRIPT_FILENAME'],'tinymce')).'zdata/zdocs/';;
		}
		$dirthumb = $dirdoc.'thumbs/';
		if ($this->isDocAuth($ident)&&($this->getValues($ident,cDocType)=='img')) {//de type image accessible
		  $docname = $this->getValues($ident,cDocFilename);
		  if (!file_exists($dirthumb.$docname) || (filemtime($dirthumb.$docname)<filemtime($dirdoc.$docname)) || $force ) {//Pas de miniature ou trop ancienne ou gnration force
				$imgname = $dirdoc.$docname;
	  		$imgthumb = $dirthumb.$docname;
					//      list($width, $height, $type, $attr) = getimagesize("$pic");
			  switch($this->getValues($ident,cDocExt)) {
    			case 'jpg': case 'jpe': case 'jpeg':
						$img = imagecreatefromjpeg($imgname);
						break;
					case 'png':
						$img = imagecreatefrompng($imgname);
						@imagealphablending($img, false);
						break;
					case 'gif':
						$img = imagecreatefromgif($imgname);
			  		break;
		      default :
  		    	break;
				}
				if (imagesx($img)>=imagesy($img)) {
					$largeur = 100; $hauteur = $largeur*imagesy($img)/imagesx($img); // paramtrer le 100 !!!
				} else {
					$hauteur = 100; $largeur = $hauteur*imagesx($img)/imagesy($img); // paramtrer le 100 !!!
				}
				$img_out = imagecreatetruecolor($largeur, $hauteur);
				@imagealphablending($img_out, false);
				imagecopyresampled($img_out, $img, 0, 0, 0, 0, imagesx($img_out), imagesy($img_out), imagesx($img), imagesy($img));
				@imagesavealpha($img_out, true);
	      imagepng($img_out,$imgthumb);
	      imagedestroy($img);
	      imagedestroy($img_out);
	      return true;
			} else return false;
		} else return false;
	}
	function makethumbs() {//gnrer les miniatures de tous les fichiers images qui ont changs
		foreach (self::$docs as $ident => $doc) {//pour chaque document
	  	$this->makethumb($ident);
		}
 	}
  function compact($change=false){//en cours
		foreach(self::$docs as $key => &$doc) {
			$change|=$this->_compactDoc($key,$doc);
		}
		if ($change) $this->save();
	}
}
?>
