<?php
/*
outils: Gestion d'un captcha
Copyright Jean-Paul GIAUSSERAND 2011
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.0: Cration
*/
function captcha_html ($captchatext='', $fontsize=40, $angle=10, $len=8, $lcolor='#00ff00'){
$out='';
if ($fontsize<=20) $fontsize=30;
if ($angle<-20 || $angle>20) $angle=10;
if ($len<4) $len=8;
$height = $fontsize*2;
$width = $fontsize*$len;
// Cration d'une image
$im = imagecreatetruecolor($width, $height);
//
$color=html2rgb($lcolor);
$back = imagecolorallocate($im, $color[0], $color[1], $color[2]);
$black = imagecolorallocate($im, 0x00, 0x00, 0x00);
// Dfinit l'arrire-plan transparent
imagefilledrectangle($im, 0, 0, $width, $height, $back);
imagecolortransparent($im, $back);
// Chemin vers la police pour le captcha
$font_file = dirname(__FILE__)."/fonts/acorninitials.ttf";
// Dessine le texte
$pass='';
for($i=0;$i<$len;$i++) {
	$c = chr(mt_rand(ord('A'),ord('Z')));
	$pass.=$c;
	$angle=-$angle;
	$x=$i*$fontsize-($i==0 ? 0: ($i%2 ? $fontsize/8 : $fontsize/4));
	imagefttext($im, $fontsize, $angle*($i%3), $x, $fontsize+15, $black, $font_file, $c);
  //imagestring($im, 0, $x, 0, $c, 0);
}
$out1=ob_get_clean(); // Prendre le tampon de sortie courant
if (ob_start()) {
	imagepng($im);
  $out=ob_get_contents();
 	ob_clean();
}
echo $out1; // Remettre les valeurs dans le tampon de sortie
imagedestroy($im);
$_SESSION['captcha']=sha1($pass); unset($pass);
$out="<div id='captcha' style='text-align:center'><img src='data:image/png;base64,".base64_encode($out)."' /><br/>$captchatext</br><input type='text' name='captcha' value='' width='100%'></div>";
return $out;
}
function captcha_isgood(){
return isset($_POST['captcha'])&&isset($_SESSION['captcha'])&&(sha1(strtoupper($_POST['captcha']))===$_SESSION['captcha']);
}
	//
function html2rgb($color) {//Conversion html->rvb
  if (substr($color,0,1)=="#") $color=substr($color,1,6);
  $tablo[0] = hexdec(substr($color, 0, 2));
  $tablo[1] = hexdec(substr($color, 2, 2));
	$tablo[2] = hexdec(substr($color, 4, 2));
  return $tablo;
}
?>