<?php
/*
ZitePLUS, Zite+
Copyright Jean-Paul GIAUSSERAND 2008-2011
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info

Pour une partie du code issu de Zite 0.6.2beta:
Copyright Renaud GOMBERT, 2007, rgombert@essentiel.net
http://zite.prositif.com
Licence : CeCILL-B, http://www.cecill.info

Ce logiciel est un programme informatique de type CMS servant diffuser et  grer le contenu d'un site web de la manire la plus simple possible.
Une (petite) partie des plus: (voir le site suivant pour une description complte: http://www.giausserand.fr/index.php?perma=ziteplus)
- Gestion modulaire 'sitemap.xml, sauvegarde du site ...'
- Gestion scurise des documents (remplace la gestion de fichiers de zite)
- Gestion des droits utilisateurs, des groupes et de la scurit des pages
	. Gestion de la cration/modification/suppression des utilisateurs
	. Gestion de la cration/modification/suppression des groupes d'utilisateurs (un utilisateur peut appartenir  plusieurs groupes)
	. Gestion de la scurit des pages en fonction des groupes utilisateurs
	La consultation d'une page peut tre accessible  tout le monde ou restreinte  un ou plusieurs groupes d'utilisateurs.
	Une page "enfant" sans droit dfini hrite automatiquement des droits de la page parente de niveau suprieur.
	Une page sans droit est accessible  tout le monde en lecture.
	Droit de lecture et d'criture spar
- Cration d'un sitemap.xml pour les moteurs de recharche
- La position dans la liste des pages est garde
- Assistant de cration de pages
- Possibilit de crer des URL, des pages latrales
- Affichage des dates de modifications des pages
- Divers changement dans le code (bugs ou fonctionalits)
	. Rcriture sauvegarde des pages
	. Modification Sitemap() pour tenir compte des droits et date de modifs des pages
	. Utilisation de constante symbolique pour faciliter la lecture du source
	. Si pas d'URL rewriting ou de multiview:
		- Le plan de site utilise les lien de type perma=xxxx
		- Le menu utilise les liens de type perma=xxxx
	. etc...
*/
@ini_set('arg_separator.output', '&amp;');
@set_magic_quotes_runtime(0);//plus en php 5.3 enfin
define('ZITEVER', 'ZitePLUS 0.9.2');
//
define('argsep','|');
//
if (phpversion()<'5') {   // Il faut php 5, msg 0.8.3b8
	exit('<h1> ZitePLUS a besoin de PHP5 pour fonctionner<br>Il faut modifier le fichier <u>.htaccess</u> en fonction de votre hbergeur<br>Consulter la <a href="http://www.giausserand.fr/index.php?perma=ziteplus_manual_php5">documentation<a></h1>');
}
//
session_start();//091-pour tdocs
//print_r(count(glob(session_save_path().'/sess_*')));
require_once 'tpages.php';
require_once 'trubs.php';
require_once 'tdocs.php';
require_once 'tmodule.php';
//
class zpbase {
	public $zpath,
		$ipath,
		$cpath,
		$dpath,
		$opath,
		$config,
		$messages,
		$module;    // liste des modules
	public function __construct($data,$code=null){
		Tmodule::set_cms($this);
		$this->ipath = $data;
		$this->zpath = empty($code)?$this->ipath.'/zplus':$code;
		$this->cpath = $this->ipath.'/zdata';
		$this->dpath = $this->cpath.'/zdocs';
		$this->opath = $this->cpath.'/zoption';
		$this->config = parse_ini_file($this->cpath.'/config.ini', true);
		@ini_set('display_errors',(bool)$this->config['site_debug']!=0);
		if ($this->config['site_debug']==1) {error_reporting(E_ERROR|E_PARSE);}
		elseif ($this->config['site_debug']==2) {error_reporting(-1);}
		if ($this->config['page_compress']==1) {ini_set('zlib.output_compression',true);}
		elseif ($this->config['page_compress']==2) {ob_start("ob_gzhandler");}
		$this->module = (array)unserialize(@file_get_contents($this->cpath.'/module.dta'));
		$this->messages = false;
	}
	public function get_message($key) {
		if (empty($this->messages)) $this->messages = @parse_ini_file($this->cpath.'/messages.ini', true);
		return array_key_exists($key, $this->messages) ? $this->messages[$key] : "[$key]";
	}
	public function get_data($key) {
		return array_key_exists($key, $this->config) ? $this->config[$key] : "[$key : DONNEE NON DEFINIE - UNKNOWN DATA]";
	}
// Autres fonctions
	function writefile($file, $content) {
		$h = fopen($file, 'w');
		if ($h) {
			$r = fwrite($h, $content);
			fclose($h);
			return $r;
		}
		return false;
	}
//
	function writeconfig($file, $content) {
	  $dta='';
		foreach ($content as $k => $v) $dta .= "\n$k = \"".str_replace('"', '&quot;', $v).'"';
		return $this->writefile($file,trim($dta));
	}
//
	function writedata($file, $content) {
		return $this->writefile($file, serialize($content));
	}
	function debug($msg) {print "|<code>".$msg."|</code><br />";}
	function version($vsrc=true){return substr(preg_replace('/[^0-9]/','',($vsrc?ZITEVER:$this->config['version'])),0,3);}
}
//
class zite extends zpbase {
	var	$args,
		$struct,    // La structure des pages
		$syspages,
		$truepage,
		$base,
		$basep,
		$content,
		$rewrite,   // 0=aucun, 1=urlrewriting, 2=multiview (free)
		$rewritebase, // Contient l'url racine du site
    $group,   	// { groupes }
    $user,  		// { utilisateurs }
		$docs,      // { documents }
		$forum,
		$isstat,$filestat,    // faut-il gnrer des statistiques - pas en prod actuellement, mais fonctionnel
		$mimetype,        // Provisoire
		$isdoc,
		$rubs,
		$pages, // La nouvelle structure de pages (remplace struct dans la 1.0)
		$event,
		$lang,
		$jquery_load;
//
	function __construct($caller, $cs=false) {
	  parent::__construct(dirname($caller),dirname(__FILE__));
	  $this->lang = $this->config['site_lang'];
	  $this->jquery_load = $this->config['jquery_load'];
//		$this->zpath = dirname(__FILE__);
//		$this->ipath = dirname($caller);
		$this->isstat = (isset($this->config['statistic'])&&($this->config['statistic']=='on'))?1:0;
		$this->filestat = $this->cpath.'/access.log';
		$this->args = @explode(argsep,$_GET['z']);
//		if (get_magic_quotes_gpc()) $_POST = array_map('stripslashes', $_POST);
		$this->struct = (array)unserialize(@file_get_contents($this->cpath.'/structure.dta'));
		$this->BuildStruct();
			// Juste au cas o on vient de Zite => prparer la premire connexion de migration
		if (!file_exists($this->cpath.'/user.dta') && isset($this->config['login_adminname'])) {//083b4
	  		$this->user[$this->config['login_adminname']] = array($this->config['login_adminpass'],'Administrateur du site',array('admin'));
	  		$this->user[$this->config['login_username']] = array($this->config['login_userpass'],'Webmestre du site',array('webmaster'));
//	  		$this->user['webmaster'][0] = $this->config['login_userpass'];
		    $this->writedata($this->cpath.'/user.dta', $this->user);
				unset($this->user);
				if (!file_exists($this->cpath.'/group.dta') && file_exists($this->zpath.'/migration/group.dta')) rename($this->zpath.'/migration/group.dta', $this->cpath.'/group.dta');
				if (!file_exists($this->cpath.'/module.dta') && file_exists($this->zpath.'/migration/module.dta')) {
					rename($this->zpath.'/migration/module.dta', $this->cpath.'/module.dta');
					$this->module = (array)unserialize(@file_get_contents($this->cpath.'/module.dta')); //091
				}
		}
    $this->group = (array)unserialize(@file_get_contents($this->cpath.'/group.dta'));
		$this->user  = (array)unserialize(@file_get_contents($this->cpath.'/user.dta'));
		$this->rubs=new Trubs($this->cpath.'/rubs.dta');
		$this->docs = new Tdocs($this->cpath.'/docs.dta');
		$this->mimetype = array();
		$this->event= (file_exists($this->cpath.'/event.dta')?(array)unserialize(@file_get_contents($this->cpath.'/event.dta')):array());
//		$this->forum =  (array)unserialize(@file_get_contents($this->cpath.'/forum/forum.dta'));
//		$this->livredor =  (array)unserialize(@file_get_contents($this->cpath.'/livredor.dta'));
		$this->content = array();
		$this->truepage = false;
		$this->rewrite = (int)$this->config['url_rewriting'];
		$dirscript = dirname($_SERVER['SCRIPT_NAME']);
		$this->rewritebase = 'http://'.$_SERVER['HTTP_HOST'].(strlen($dirscript)==1?'/':$dirscript.'/');
		$this->base = $this->config['files_index'].'?z=';
		$this->basep =$this->config['files_index'].'?perma=';
		$this->syspages = array('login', 'logout','admin','page_editor','page_extended', 'source_editor', 'delete', 'sitemap','selectgroup','module','option');
		foreach ($this->module as $clef => $valeur ) {
			if ($valeur[cModulOn]==1) $this->syspages[]=strtolower($valeur[cModulIdent]);
		}
		if($cs || !array_key_exists('zite_admin',$_SESSION) || $_SESSION['zite_id'] != $this->config['site_id']) {
			session_unset(); 
			$_SESSION['zite_admin'] = 0;
			$_SESSION['zite_id'] = $this->config['site_id'];
			$_SESSION['showadminbar'] = false;
			$_SESSION['zite_usergroup']=array();
		}
		$_SESSION['url_base'] = $this->rewrite ? ($this->rewrite===2?$this->config['files_index']:'') : $this->basep;
		$_SESSION['url_rewrite']=$this->rewrite;
		$_SESSION['url_rewritebase']=$this->rewritebase;
		$this->isdoc=false;
		$this->content['pnl1']=$this->content['pnl2']=$this->content['pnl3']=$this->content['pnl4']=$this->content['pnl5']=$this->content['pnl6']=$this->content['pnl7']=$this->content['pnl8']=$this->content['pre_main']=$this->content['post_main']='';
		$this->content['dftcss']=$this->content['localcss']=$this->content['css']=$this->content['js']=$this->content['menu_title']='';
		$this->pages=null;
	}
//
	function builder() {
			// Gestion du multiviews de Free ou autre (! il faut une directive <base> dans le template)
		if ($this->rewrite==2) {
			if (!array_key_exists('z',$_GET)) {
				$v = explode('.',basename($_SERVER['REQUEST_URI']));
				if ((count($v)==2)&&($v[1]=='html')) {//modif jpg
					if (!array_key_exists('z',$_GET)) {
						$_GET['perma']=$v[0];
					}
				} else {
				$_GET['z'] = $this->args[0] = 1;
				}
			}
		}
		if (array_key_exists('perma', $_GET)) {
			$z=$this->page_from_ident($_GET['perma']);
			if ($z===false) {
					$this->content['main'] = $this->get_message('error404');
					header("HTTP/1.0 404 Not Found");
			}
			$_GET['z'] = $this->args[0] = $z;
		}
		if (array_key_exists('doc',$_GET)) {//obsolte en 090->//091 => view.php
		  $this->isdoc=true;
      @ob_end_clean();//091
		  header('Location: view.php/'.$_GET['doc']);
		  exit;
		}
		$page = isset($_GET['z'])&&strlen($_GET['z']) ? $this->args[0] : 1;  // fixer page en cours
		if (in_array($page, $this->syspages)) {   // Est-ce une page systme ?
			$pagefun = "page_$page";
			if (in_array($page.'.php', array_keys($this->module))) { // page de module
				$this->content['main'] = $this->page_module($page);
			} else $this->content['main'] = $this->$pagefun();  // vrai page systme
		} else { // page standard
			if ($this->config['site_status']||($_SESSION['zite_admin']>0)) {
				if (array_key_exists($page, $this->struct) && ($this->struct[$page][cPageOn] || $_SESSION['zite_admin']>0)) {
							// Voir si la page est affichable
					$infos = $this->struct[$page];
					if ($this->isPageAuth($page)) {
						$this->content['page_navtitle'] = empty($infos[cPageNavTitle])?$infos[cPageTitre]:$infos[cPageNavTitle];
						$this->content['menu_title'] = $this->content['page_navtitle']; ///////////////////////////////////////// Provisoire  supprimer par la migration !!!
						$this->content['page_desc'] = isset($infos[cPageDesc])?$infos[cPageDesc]:$infos[cPageTitre];
						$this->content['page_keyword'] = isset($infos[cPageKeyword])?$infos[cPageKeyword]:'';
						$this->truepage = $page;  // devrait tre aprs le test suivant !!!  vrifier et dplacer
						if (($infos[cPageType]&pgbitType)!=5) {
						  $_SESSION['truepage']=$this->truepage;
							$tmp = $this->get_content($infos[cPageIdent], ($infos[cPageType]%2)==0 , true);
							$this->content['main'] = $tmp ? $tmp : $this->get_message('errorNOFILE');
//							$this->content['main'] = $tmp ? '<div id="p_'.$infos[cPageIdent].'">'.$tmp.'</div>' : $this->get_message('errorNOFILE');
						} else header('Location: '.$infos[cPageIdent]); // si URL
				 	} else {
				 	$this->content['main'] = $this->get_message('error401');} // page interdite
          //header('HTTP/1.0 401 ident error');
				} else {
						$this->content['main'] = $this->get_message('error404');
						header("HTTP/1.0 404 Not Found");
				}
			} else {
				$this->content['main'] = $this->get_message('errorCLOSED');
			}
		}
		$this->navbuilder();
		if ($_SESSION['showadminbar']) $this->prepend($this->adminbar());
	}
//
	function navbuilder() {
		$n = $this->truepage ? $this->truepage : 1;
		$this->pages=new Tpages($this->truepage,$this->struct);
		$isadmin = (int)$_SESSION['zite_admin']>0;
		$rewrite = $this->rewrite && !$isadmin;
		$base = $this->rewrite ? ($isadmin ? $this->basep.$this->get_data('navig_admin') : ($this->rewrite===2?$this->config['files_index']:' ')) : $this->basep;
		$max = count($this->struct);
//
		$this->doevent(eMenu,eBefore,$out);
//
		$nav = '';
		$s = $this->struct[$n];
		if (($s[cPageType]&pgbitMenu)!=pgbitMenu) {
			if ($n==1) {	//Premire page
				$nav = '<li class="zli1 zon"><a href="'.preg_replace('/\/[^\/]*$/','',$_SERVER['REQUEST_URI']).'/">'.$s[cPageTitre].'</a></li>';
			} else {
				if ($s[cPageOn] || $isadmin) $nav = '<li class="zli'.$s[cPageRang].' zon"><a href="'.$base.($rewrite ? $s[cPageIdent].'.html' : $s[cPageIdent]).'" '.((($s[cPageType]&pgbitType)==5)&&(isset($s[cPageOpt]['target']))?'target="_blank"':'').'>'.$s[cPageTitre].'</a></li>';
			}
		}
		$td = $s[2];
		if ($n>1) {
			for ($i=$n-1; $i>0; $i--) {
				$s = $this->struct[$i];
				$d = $s[2];
				if (($s[cPageType]&pgbitMenu)!=pgbitMenu) {
					if ($i==1) {
						$nav = '<li class="zli1'.(isset($this->pages->pgcf[$i])?' zonp':'').'"><a href="'.preg_replace('/\/[^\/]*$/','',$_SERVER['REQUEST_URI']).'/">'.$s[cPageTitre].'</a></li>'.$nav;
					} else {
						if ($d<=$td && ($s[cPageOn] || $isadmin)) {
							//if ($d<$td) $this->parents[$s[0]] = $i;
							$td = $d;
							$f = $rewrite ? $s[cPageIdent].'.html' : $s[0];
							if ($this->isPageAuth($i)) {
							  if (($s[cPageType]&pgbitPosSide)==pgbitPosSide) {
							    if (!isset($s[cPageOpt])||($s[cPageOpt]&1)) $nav = '<li class="zli'.$d.'">'.$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true).'</li>'.$nav;
									if ($s[cPageOpt]&2) $this->content['pnl2']=$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true).$this->content['pnl2'];
									if ($s[cPageOpt]&4) $this->content['pnl3']=$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true).$this->content['pnl3'];
									if ($s[cPageOpt]&8) $this->content['pnl4']=$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true).$this->content['pnl4'];
									if ($s[cPageOpt]&16) $this->content['pnl5']=$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true).$this->content['pnl5'];
									if ($s[cPageOpt]&32) $this->content['pnl6']=$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true).$this->content['pnl6'];
									if ($s[cPageOpt]&64) $this->content['pnl7']=$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true).$this->content['pnl7'];
									if ($s[cPageOpt]&128) $this->content['pnl8']=$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true).$this->content['pnl8'];
							  } else {
								$nav = '<li class="zli'.$d.(isset($this->pages->pgcf[$i])?' zonp':'').'"><a href="'.(($s[cPageType]&pgbitType)!=5?$base.$f:$s[cPageIdent]).'">'.$s[cPageTitre].'</a></li>'.$nav;
								}
							}
						}
					}
				}
			}
		}
		$td=$this->struct[$n+1][cPageRang];
		for ($i=$n+1; $i<=$max; $i++) {
			$s = $this->struct[$i];
			$d = $s[cPageRang];
			if ($d<=$td && ($s[cPageOn] || $isadmin)) {
				$td = $d;
				$f = $rewrite ? $s[cPageIdent].'.html' : $s[cPageIdent];
				if ($this->isPageAuth($i)&&($s[cPageType]&pgbitMenu)!=pgbitMenu) {
				  if (($s[cPageType]&pgbitPosSide)==pgbitPosSide) {
				    if (!isset($s[cPageOpt])||($s[cPageOpt]&1)) $nav .= '<li class="zli'.$d.'">'.$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true).'</li>';
						if ($s[cPageOpt]&2) $this->content['pnl2'].=$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true);
						if ($s[cPageOpt]&4) $this->content['pnl3'].=$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true);
						if ($s[cPageOpt]&8) $this->content['pnl4'].=$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true);
						if ($s[cPageOpt]&16) $this->content['pnl5'].=$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true);
						if ($s[cPageOpt]&32) $this->content['pnl6'].=$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true);
						if ($s[cPageOpt]&64) $this->content['pnl7'].=$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true);
						if ($s[cPageOpt]&128) $this->content['pnl8'].=$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true);
					} else {
				    $nav .= '<li class="zli'.$d.'"><a href="'.(($s[cPageType]&pgbitType)!=5?$base.$f:$s[cPageIdent].(isset($s[cPageOpt]['target'])?'" target="'.$s[cPageOpt]['target']:'')).'">'.$s[cPageTitre].'</a></li>';
					}
      	}
			}
	  }
		if ($this->config['menu_type']==1) {  //0=menu standard 1=menu droul fixe
			$nav = '';
			for ($i=1; $i<=$max; $i++) {
				$s = $this->struct[$i];
				$d = $s[cPageRang];
				if ($s[cPageOn] || $isadmin) {
					$f = $rewrite ? $s[cPageIdent].'.html' : $s[cPageIdent];
					if ($this->isPageAuth($i)&&($s[cPageType]&pgbitMenu)!=pgbitMenu) {
					  if (($s[cPageType]&pgbitPosSide)==pgbitPosSide) {
					    if (!isset($s[cPageOpt])||($s[cPageOpt]&1)) $nav .= '<li class="zli'.$d.'">'.$this->get_content($s[cPageIdent],($s[cPageType]%2)==0,true).'</li>';
						} else {
							if ($i==1) {
								$b=explode('/',$_SERVER['REQUEST_URI']);
								$nav .= '<li class="zli1"><a href="'.preg_replace('/\/[^\/]*$/','',$_SERVER['REQUEST_URI']).'/">'.$s[cPageTitre].'</a></li>'.$nav;
							} else {
					    	$nav .= '<li class="zli'.$d.($this->truepage==$i?' zon':(isset($this->pages->pgcf[$i])?' zonp':'')).'"><a href="'.(($s[cPageType]&pgbitType)!=5?$base.$f:$s[cPageIdent].(isset($s[cPageOpt]['target'])?'" target="'.$s[cPageOpt]['target']:'')).'">'.$s[cPageTitre].'</a></li>';
							}
						}
      		}
				}
  		}
		} else if ($this->config['menu_type']==2) {  //2=menu hirarchique <------------  finir
		  $nav = '';
		  $this->content['menuh']=$nav;
		}
		$this->content['menu'] = '<ul class="zul">'.$nav.'</ul>';
	}
//
	function output() { // mettre constante pour multilangue !!
	  if (!$this->isdoc) {
			$out='';
			$this->doevent(eOutput,eBefore,$out);
			$this->append($this->truepage?('<p align="right">'.($this->config['page_date']?('<small><br /><br /><br /><br /><br />Dernire modification le '.date("d/m/Y ", filemtime($this->cpath.'/'.$this->struct[$this->truepage][cPageIdent].'.txt')).'</small>'):'').($this->isPageAuth($this->truepage,cPageWrite)?'<a href="index.php?z=page_editor|'.$this->truepage.'"><img src="deco/edit.png" alt=""/></a>':'').'</p>'):'');
			$this->content['main'] = $this->content['pre_main'].$this->content['main'].$this->content['post_main'];
			if (!isset($this->content['page_navtitle'])) $this->content['page_navtitle'] = $this->get_data('site_title'); // <------------- paramtre global pour toujours mettre le titre du site !!!!
			if (!isset($this->content['page_desc'])) $this->content['page_desc'] = $this->config['site_description'];
			if (!isset($this->content['page_keyword'])) $this->content['page_keyword']=$this->config['site_keywords'];
			if ($this->config['version']<'ZITEPLUS 0.9.0') $this->content['menu'] = $this->content['pnl2'].$this->content['menu'].$this->content['pnl3'];
			ob_start();
///			$zite = $this; // C'est pour le template => plus utile  compter de la 0.9.2.a7
//			$this->doevent(eTemplate,eBefore,$out);
			require($this->ipath.'/'.$this->config['files_template']);
//		  $this->doevent(eTemplate,eAfter,$out);
			$this->doevent(eOutput,eAfter,$out);
			return ob_get_clean();
		} else { return '';}
	}
//
	function adminbar() {
		if ($_SESSION['showadminbar']) {
			$admin = $_SESSION['zite_admin']==2;
			$out = $_SESSION['zite_user']?$_SESSION['zite_user'].':':'Menu :';//  $admin ? $this->get_message('admin_admintitle') : $this->get_message('admin_usertitle');
	    if ($_SESSION['zite_admin']) {
				$out .= ' <a href="'.$this->base.'admin'.($this->truepage?'#'.$this->truepage:'').'">'.$this->get_message('edit_admin').'</a>';
				if ($this->truepage && ($this->isPageAuth($this->truepage,cPageWrite))) $out .= ' <a href="'.$this->base.'page_editor|'.$this->truepage.'">'.$this->get_message('edit').'</a>';
				if ($this->truepage && $admin) $out .= ' <a href="'.$this->base.'source_editor|'.$this->truepage.'">'.$this->get_message('edit_source').'</a>';
			}
			foreach ($this->module as $clef => $valeur ) {
				if (($valeur[cModulOn]==1)&&(empty($valeur[cModulUse]) || (array_intersect($valeur[2],$_SESSION['zite_usergroup'])) != array())&&($this->get_message($valeur[0].'_admin'))) {
					$out .= ' <a href="'.$this->base.'module|'.$valeur[0].'">'.$this->get_message($valeur[0].'_admin').'</a>';
		    }
		  }
			$out .= ' <a href="'.$this->base.'logout">'.$this->get_message('logout').'</a>';
			return '<div id="zadmin">'.$out.'</div>';
		}
	}
//
	function get_content($key, $php=false, $div=false)/*, $stat=false)*/ {
		$key = preg_replace('/[^A-z0-9_-]/','',$key);
		$file = $this->cpath."/$key.txt";
		if (!file_exists($file)) {return false;}
		if (($this->isstat) && $stat) {
      @file_put_contents($this->filestat,date('Y-m-d H:i:s:u')." $_SERVER[REMOTE_ADDR] $_SERVER[REQUEST_URI] $key $_SESSION[zite_user]\r\n",LOCK_EX|FILE_APPEND);
		}
		if ($php) {
			ob_start();
			$zite = $this;// <------- voir si toujours utile en ziteplus: non  <------------------------------------ (et $cms)------------------------<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
			include($file);
			return ($div&&($this->config['page_div'])?'<div id="pg_'.$key.'">':'').ob_get_clean().($div&&($this->config['page_div'])?'</div>':'');
		} else {
			return ($div&&($this->config['page_div'])?'<div id="pg_'.$key.'">':'').file_get_contents($file).($div&&($this->config['page_div'])?'</div>':'');
		}	
	}
//
	function prepend($text) {$this->content['pre_main'] .= $text;}
	function append($text) {$this->content['post_main'] = $text . $this->content['post_main'];}
//
//
// Fonctions-pages
//
	function page_login() { // jpg-ok
 		$out = '';
		if (!empty($_POST['id'])) {
	    $_POST['id'] = strtolower($_POST['id']);
			if (array_key_exists($_POST['id'],$this->user) && (strcmp($this->user[$_POST['id']][0],md5($_POST['pass']))==0) && ($this->user[$_POST['id']][3]==false)) {
					$errcaptcha=false;
					$this->doevent(eCaptcha,eAfter,$errcaptcha);
				if (empty($this->config['login_captcha']) || !$errcaptcha) { //// si bon code de scurit (CAPTCHA)
			  	if ((!$this->config['user_cgu']) || $this->user[$_POST['id']][7]) {
						$_SESSION['zite_user'] = $_POST['id'];      // fixer utilisateur en cours
						$_SESSION['zite_usergroup'] = $this->user[$_POST['id']][2];  // fixer groupes en cours
  	    		$_SESSION['showadminbar']=(bool)$_POST['showadminbar'];
						if (in_array('webmaster',$_SESSION['zite_usergroup'])) {  // un webmaster
	      	  	$_SESSION['zite_admin'] = 1;
	      	  	header('Location: '.$this->base.(isset($_POST['returnpage'])?$_SESSION['truepage']:''));
						} elseif (in_array('admin',$_SESSION['zite_usergroup'])) { // un admin
					  	$_SESSION['zite_admin'] = 2;
					  	if ($this->config['version']==ZITEVER) {
						  	header('Location: '.$this->base.(isset($_POST['returnpage'])?$_SESSION['truepage']:'admin'));
					  	} else { // version pas  jour => proposer une migration automatique
								if ($this->module['migration.php'][cModulOn]==0){
									$file = $this->cpath.'/module.dta';
									$module = &$this->module;
									$module['migration.php'][cModulOn] = 1;
						 			$this->writedata($file, $module);
								}
								header('Location: '.$this->base.'migration');
			 				}
	    			} else {  // un autre type d'utilisateur
	      			$_SESSION['zite_admin'] = 0;
	      			$_SESSION['showadminbar']=false;
							header('Location: '.$this->base.(isset($_POST['returnpage'])?$_SESSION['truepage']:''));
						}
						exit;
					} else {
					  $id=$_POST['id'];
					  $pass=$_POST['pass'];
					  $showadminbar=(bool)$_POST['showadminbar'];//test090
					  $returnpage=$_POST['returnpage'];//test090
					  $out= $this->page_module('user_cgu');// il faut approuver les CGU;
					}
				} 
	  	} else $this->msgShow('errLOGIN');
	 	}
  	$ver=phpversion();
  	if ($ver[0]<'5') {   // Il faut php 5 !! ajout 0.8.1
  	  $this->msgShow("ZitePLUS rclame PHP5 pour fonctionner: consulter la documentation",false);
		}
		if (empty($out)) {
			$out .= '<form method="post" id="login_form" action="'.$this->base.'login" enctype="multipart/form-data"><table class="ztable">';
			$out .= '<tr><td colspan="2"><h1>Identification</h1></td></tr>';
			$out .= '<tr><td width ="180">'.$this->get_message('user_username').'</td><td><input name="id" type="text" value="'.(isset($id)?$id:'').'"/></td></tr>';
			$out .= '<tr><td>'.$this->get_message('user_password').'</td><td><input name="pass" type="password" value="'.(isset($pass)?$pass:'').'" /></td></tr><tr><td colspan="2"><br /></td></tr>';
			$out .= '<tr><td></td><td>'.$this->get_message('login_showadminbar').'<input name="showadminbar" type="checkbox" value="1" checked="checked" /></td></tr><tr><td colspan="2"></td></tr>';
			$out .= '<tr><td></td><td>'.$this->get_message('login_returnpage').'<input name="returnpage" type="checkbox" value="0" /></td></tr>';
			if ($this->config['login_captcha']) {
				$out .='<tr><td colspan="2"><br />';$this->doevent(eCaptcha,eBefore,$out);$out.='</td></tr>';
			}
			$out .='<tr><td colspan="2"><br /></td></tr>';
			$out .= '<tr><td colspan="2"><input type="submit" name="Submit" value="'.$this->get_message('connect').'" /></td></tr></table></form>';
		}
	 	return $out;	//$this->get_message('login_form');
	}
//
	function page_logout() {
	  $this->doevent(eLogout,eBefore,$out);
		session_unset();
		header('Location: '.$this->base);
		exit;
	}
//
	function page_option() {return $this->page_module('page_admin','option');}
	function page_admin() {return $this->page_module('page_admin');}
	function page_delete() {return $this->page_module('page_admin','delete');}
	function page_page_editor() {return $this->page_module('page_admin','page_editor');}
	function page_source_editor() {return $this->page_module('page_admin','source_editor');}
//
	function page_sitemap() {   //jpg.20090204 W3C.20091201
		$base = $this->rewrite ? ($this->rewrite===2?$this->config['files_index']:'') : $this->basep;
		$nav = '';
		foreach ($this->struct as $idpage => $page) {
			if ($page[cPageOn] && $this->isPageAuth($idpage) && ($page[cPageIdent][0]!='_')) {
				$dtlastmaj = ($page[cPageType]&pgbitType)==5?'': ' '.date("d/m/Y ", filemtime($this->cpath.'/'.$page[cPageIdent].'.txt')).'';
				$nav .= '<tr><td style="width:500px"><div class="zli'.$page[cPageRang].'"><a href="'.(($page[cPageType]&pgbitType)!=5?($base.($this->rewrite ? $page[0].'.html' : $page[cPageIdent])):$page[cPageIdent]).'">'.$page[cPageTitre].'</a></div></td><td>'.$dtlastmaj.'</td></tr>';
			}
		}
		return '<h1>'.$this->get_message('sitemap').'</h1><table class="zul">'.$nav.'</table>';
	}
//
	function swap($p) {
		$t = $this->struct[$p-1];
		$this->struct[$p-1]=$this->struct[$p];
		$this->struct[$p]=$t;
		$this->buildStruct();
	}
	function swap2($a,$b) {
		$t = $this->struct[$a];
		$this->struct[$a]=$this->struct[$b];
		$this->struct[$b]=$t;
		$this->buildStruct();
	}
//
	function page_selectgroup() { //jpg //  dplacer
		if ($_SESSION['zite_admin']) {
			if ($_POST['save']==1) {    // Sauvegarder les changements
				$dta = & $this->struct[$_POST['page']];
			  $readwrite = $_POST['readwrite'];
				$dta[$readwrite] = empty($_POST['group'])?array():explode(':',$_POST['group']);
				$this->writeStruct();
				header('Location: '.$this->base.'admin');
			} else {
			$max = count($this->struct);
			$p = (int)$this->args[1];
			if ($p>0 && $p<=$max && $max>1) {
				if ($_SESSION['zite_admin']==2) {//$this->isPageAuth($p,cPageWrite)) // droit de modifier les droits des pages
							if ($this->args[2]=='i') {     		 // premire initialisation
							  $readwrite = $this->args[3];
							  $g = $this->struct[$p][$readwrite];
							  $g1 = empty($g)?'':implode(':',$g);
								}
							elseif ($this->args[2]=='g') {  // Mise  jour
								$g = (empty($this->args[3])?array():explode(':', $this->args[3]));
								if (in_array($this->args[4],$g)) {
									  $g2[] = $this->args[4];
                    $g = array_diff($g, $g2);
										}
								else {
										$g[]=$this->args[4];
										}
							  $g1 = empty($g)?'':implode(':',$g);
							  $readwrite = $this->args[5];
								}
					    $f = $this->group;  // copie du tableau des groupes
							uksort($f, create_function('$a, $b', 'return strcmp($a[0], $b[0]);'));

							$out = '<form method="post" action="'.$this->base.'selectgroup" enctype="multipart/form-data"><table class="ztable">';
							$out .= '<tr><td><h2>'.($readwrite==cPageWrite?$this->get_message('selectgroup_write'):$this->get_message('selectgroup_read')).'<center><strong><h1>'.$this->struct[$p][1].'</h1></strong></center></h2><td></tr>';
									// Afficher la liste de tous les groupes
							$out .= '<tr><td colspan="2"><input type="submit" name="Submit" value="'.$this->get_message('submit').'" /><input name="save" type="hidden" value="1" /><input name="page" type="hidden" value="'.$p.'" /><input name="group" type="hidden" value="'.$g1.'" /><input name="readwrite" type="hidden" value="'.$readwrite.'" /></td></tr></table></form>';
							$out .= '<table class="ztable">';//<tr><td><h2>Liste de tous les groupes</></td></tr>';
							$out .= '<tr bgcolor="#CCCCCC"><td>'.$this->get_message('groupes_name').'</td><td>'.$this->get_message('groupes_desc').'</td><td></td></tr>';
							foreach ($f as $clef => $valeur	) {
								$out .= '<tr bgcolor="#'.(++$i%2 ? 'DDDDDD' : 'EEEEEE').'"><td>'.$clef.'</a></td><td>'.$valeur.'</td>';
								$out .= '<td><a href="'.$this->base.'selectgroup|'.$p.'|g|'.$g1.'|'.$clef.'|'.$readwrite.'"><img src="deco/k'.($readwrite==cPageWrite?'w':'r').(in_array($clef,$g)?'1' : '0').'.png" alt=""/></a></td></tr>';
								}
							$out .= '</table>';
							$out .= $readwrite==cPageWrite?$this->get_message('selectgroup_commentwrite'):$this->get_message('selectgroup_commentread');
              return $out;
							//$this->get_message('delpage_confirm').'<p class="zalert"><a href="'.$this->base.'delete|'.$p.'|ok">'.$this->get_message('delpage').'<strong>'.$this->struct[$p][1].'</strong></a></p>';
							}
						else {
					return $this->get_message('not_allowed');
				}
			} else {
				return $this->get_message('not_possible');
			}
		} }else {
			return $this->get_message('not_allowed');
		}
	}
 		// Vrifier les droits en lecture sur la page (jpg)
	function isPageAuth($nopage, $typedroit=6, $usergroup=null) {//modif 091
			// Hriter des droits des parents si pas de droit propres
  	while (empty($this->struct[$nopage][$typedroit]) && ($this->struct[$nopage][cPageRang]!=1)&&($nopage>1)) {
			$nopage = $this->struct[$nopage][cPagePere];  // Prendre la page parente
		}
		$page = $this->struct[$nopage];
		if (empty($usergroup)) {
			$usergroup=isset($_SESSION['zite_usergroup'])?(array)$_SESSION['zite_usergroup']:array();
			$useradmin=$_SESSION['zite_admin']==2;
		} else {
			$useradmin = in_array('admin',$usergroup);
		}
		$m = array_intersect($page[$typedroit]	,$usergroup); // enlever message erreur si valeur null
		return ((empty($page[$typedroit])&&($typedroit==cPageRead)) || !empty($m) || $useradmin);
	}
		// reconstruire la liste des parents (jpg)
	function buildStruct() {
		$max = count($this->struct);
		$pere = array();
		for ($i=1; $i<=$max; $i++) {
			$p = $this->struct[$i];
			$pere[$p[cPageRang]] = $i;
			if ($p[cPageRang]==1) {
				$this->struct[$i][cPagePere]=1;
			} else {
//				$this->struct[$i][cPagePere]=$pere[$p[cPageRang]-1]; //pb ici si pas continuit des rangs
			  $j=$p[cPageRang]-1; while (!isset($pere[$j])) $j--; // prendre le 1 rang qui existe  // a corriger pour 091
				$this->struct[$i][cPagePere]=$pere[$j];
			}
		}
	}
		// Enregister la structure des pages (jpg)
	function writeStruct($rebuild = false) {
	  if ($rebuild) {
			$this->buildStruct();
		}
		return $this->writedata($this->cpath.'/structure.dta', $this->struct);
	}
		// implementation de la fonction de module avec gestion de la scurit
	function page_module($modulename="",$opt="",$cmd="job") {//jpg
		$m = empty($modulename)?strtolower($this->args[1]):strtolower($modulename);
		if (empty($modulename)) $modulename = strtolower($this->args[1].'.php');
		else $modulename .= '.php';
		if (!empty($modulename) && array_key_exists($modulename,$this->module) && ($this->module[$modulename][cModulOn]==1) && (file_exists($this->zpath.'/module/'.$modulename))) {
			if (empty($this->module[$modulename][cModulUse])||($_SESSION['zite_admin']==2)||(array_intersect($this->module[$modulename][cModulUse],$_SESSION['zite_usergroup'])!= array())) {
				$mo = Tmodule::create_module($m);
				return Tmodule::execute_module($m,$mo,$cmd,$opt);
			} else return $this->get_message('not_allowed');
		}  else return $this->get_message('not_possible');
	}
//
	function msgShow($msg,$cte=true) {//jpg
		$this->prepend('<div class="zalert">'.($cte?$this->get_message($msg):$msg).'</div>');
		return false; // ajout 0.8.3 a5
	}
	function page_from_ident($idpage) {//090&091      // obsolete en 1.0
	  $z=false;
		foreach ($this->struct as $k => $v) if ($v[cPageIdent]==$idpage) {$z=$k;break;}
		return $z;
	}
	function NO_magic_quotes() {//pas en service
	  if (get_magic_quotes_gpc()) {//090
	    foreach ($_POST as $key => $value) {
	      if (is_string($_POST[$key])) $_POST[$key] = stripslashes($_POST[$key]);
			}
		}
	}
	function makeURL($idpage,$full=false,$modeurl=-1) {//091:en cours de test
		$url = '';
		if ($modeurl==-1) $modeurl = $this->rewrite;
		$base = $modeurl ? ($modeurl===2?$this->config['files_index']:'') : $this->basep;
		if (isset($this->struct[$idpage])) {
		  $page = $this->struct[$idpage];
			$url = $idpage==1?'':(($page[cPageType]&pgbitType)!=5?($base.($modeurl ? $page[cPageIdent].'.html' : $page[cPageIdent])):$page[cPageIdent]);
		}
		if ($full && (strpos($url,'http://')===false)) {
		  $url = $this->rewritebase.$url;
		}
		return $url;
	}
	function head() {//091
	  $out='';
	  $this->doevent(eHead,eBefore,$out);
		if (!empty($this->content['dftcss'])) {		  $out.= "<style type='text/css'>".$this->content['dftcss']."</style>\n";		}
		if (!empty($this->content['css'])) {			$out.=$this->content['css'];		}
		if (isset($_SESSION['skin_demo'])) {
		  $test_stylecms = $_SESSION['skin_demodir'].'/cms.css';
		  $test_styleskin = $_SESSION['skin_demodir'].'/'.$_SESSION['skin_demoname'].'.css';
			$out .= "<link href='{$test_stylecms}' rel='stylesheet' type='text/css'/>\n";
			$out .= "<link href='{$test_styleskin}' rel='stylesheet' type='text/css'/>\n";
		} else {
			if (!empty($this->config['files_stylecms'])) $out .="<link href='{$this->config['files_stylecms']}' rel='stylesheet' type='text/css'/>\n";
			if (!empty($this->config['files_styleskin'])) $out .="<link href='{$this->config['files_styleskin']}' rel='stylesheet' type='text/css'/>\n";
		}
		if (!empty($this->config['files_styleuser'])) {
			$out .="<link href='{$this->config['files_styleuser']}' rel='stylesheet' type='text/css' />\n";
		}
		if (!empty($this->content['localcss'])) {		  $out.= "<style type='text/css'>".$this->content['localcss']."</style>\n";		}
		if (!empty($this->config['files_styleprint'])) {			$out .="<link href='{$this->config['files_styleprint']}' rel='stylesheet' type='text/css' media='print'/>\n";		}
		if ($this->config['jquery_load'] || !empty($this->jquery_load)){
			$out.='<script type="text/javascript" src="'.(empty($this->config['jquery_link'])?'https://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js':$this->config['jquery_link']).'"></script>';
		}
		if (!empty($this->content['js'])) {
			$out.=$this->content['js'];
		}
	  $this->doevent(eHead,eAfter,$out);
		return $out;
	}
	function filariane($sep='>',$title='') {//091
		$isadmin = (int)$_SESSION['zite_admin']>0;
		$base = $this->rewrite ? ($isadmin ? $this->basep.$this->get_data('navig_admin') : ($this->rewrite===2?$this->config['files_index']:' ')) : $this->basep;
	  $out='';
	  if ($this->pages->pgcf) {
			foreach ($this->pages->pgcf as $nopage => $ident) {
	  		$out = (strlen($out)?'<a href="'.$this->makeURL($nopage,true).'">'.$this->struct[$nopage][cPageTitre].'</a>'.$sep:$this->struct[$nopage][cPageTitre]).$out;
			}
     	$out = '<div id="filariane">'.($title?'<a href=".">'.$title.'</a>':'').$out.'</div>';
		}
	  return $out;
	}
	function register_event($event,$mode,$modulename) {//091
	  if (!isset($this->event[$event]) || !isset($this->event[$event][$mode]) ||!in_array($modulename,$this->event[$event][$mode])) {
		  $this->event[$event][$mode][]=$modulename;
		  $this->writedata($this->cpath.'/event.dta',$this->event);
		}
	}
	function unregister_event($modulename){//091
	  $change=false;
		foreach($this->event as $kevent => $event){
		  foreach($event as $kmode => $mode){
		    foreach($mode as $knom => $nom) {
			    if ($nom==$modulename) {unset($this->event[$kevent][$kmode][$knom]); $change=true;};
				}
			}
		}
		if ($change) $this->writedata($this->cpath.'/event.dta',$this->event);
	}
	function doevent($event,$mode,&$out,$opt=null) {//091
	  if (isset($this->event[$event][$mode])) {
	    foreach($this->event[$event][$mode] as $modulename){
				$mo = Tmodule::create_module($modulename);
				if ($mo) $mo->Event($event,$mode,$out,$opt);
			}
		}
	}
}
?>